.lib "JV-ODE.dll"

; ### World Functions
dInitODE():"_odeInitODE@0"
dInitODE2(initflags):"_odeInitODE2@4"
dAllocateODEDataForThread%(allocateflags):"_odeAllocateODEDataForThread@4"
dCleanupODEAllDataForThread():"_odeCleanupODEAllDataForThread@0"
dWorldCreate%():"_odeWorldCreate@0"
dWorldDestroy(world):"_odeWorldDestroy@4"
dWorldSetGravity(world,x#,y#,z#):"_odeWorldSetGravity@16"
dWorldGetGravity(world):"_odeWorldGetGravity@4"
dWorldSetERP(world,erp#):"_odeWorldSetERP@8"
dWorldGetERP#(world):"_odeWorldGetERP@4"
dWorldSetCFM(world,cfm#):"_odeWorldSetCFM@8"
dWorldGetCFM#(world):"_odeWorldGetCFM@4"
dWorldSetAutoDisableFlag(world,doautodisable):"_odeWorldSetAutoDisableFlag@8"
dWorldGetAutoDisableFlag%(world):"_odeWorldGetAutoDisableFlag@4"
dWorldSetAutoDisableLinearThreshold(world,lthreshold#):"_odeWorldSetAutoDisableLinearThreshold@8"
dWorldGetAutoDisableLinearThreshold#(world):"_odeWorldGetAutoDisableLinearThreshold@4"
dWorldSetAutoDisableAngularThreshold(world,athreshold#):"_odeWorldSetAutoDisableAngularThreshold@8"
dWorldGetAutoDisableAngularThreshold#(world):"_odeWorldGetAutoDisableAngularThreshold@4"
dWorldSetAutoDisableSteps(world,steps):"_odeWorldSetAutoDisableSteps@8"
dWorldGetAutoDisableSteps%(world):"_odeWorldGetAutoDisableSteps@4"
dWorldSetAutoDisableTime(world,time#):"_odeWorldSetAutoDisableTime@8"
dWorldGetAutoDisableTime#(world):"_odeWorldGetAutoDisableTime@4"
dWorldImpulseToForce(world,stepsize#,ix#,iy#,iz#):"_odeWorldImpulseToForce@20"
dCloseODE():"_odeCloseODE@0"
dWorldStep(world,stepsize#):"_odeWorldStep@8"
dWorldQuickStep(world,stepsize#):"_odeWorldQuickStep@8"
dWorldSetQuickStepNumIterations(world,num):"_odeWorldSetQuickStepNumIterations@8"
dWorldGetQuickStepNumIterations%(world):"_odeWorldGetQuickStepNumIterations@4"
dWorldSetContactMaxCorrectingVel(world,vel#):"_odeWorldSetContactMaxCorrectingVel@8"
dWorldGetContactMaxCorrectingVel#(world):"_odeWorldGetContactMaxCorrectingVel@4"
dWorldSetContactSurfaceLayer(world,depth#):"_odeWorldSetContactSurfaceLayer@8"
dWorldGetContactSurfaceLayer#(world):"_odeWorldGetContactSurfaceLayer@4"
dWorldStepFast1(world,stepsize#,maxiterations):"_odeWorldStepFast1@12"
dWorldSetAutoEnableDepthSF1(world,autoenabledepth):"_odeWorldSetAutoEnableDepthSF1@8"
dWorldGetAutoEnableDepthSF1%(world):"_odeWorldGetAutoEnableDepthSF1@4"
dWorldSetQuickStepW(world,overrelaxation#):"_odeWorldSetQuickStepW@8"
dWorldGetQuickStepW#(world):"_odeWorldGetQuickStepW@4"
dWorldGetLinearDamping#(world):"_odeWorldGetLinearDamping@4"
dWorldGetAngularDamping#(world):"_odeWorldGetAngularDamping@4"
dWorldSetLinearDamping(world,scale#):"_odeWorldSetLinearDamping@8"
dWorldSetAngularDamping(world,scale#):"_odeWorldSetAngularDamping@8"
dWorldSetDamping(world,linear_scale#,angular_scale#):"_odeWorldSetDamping@12"
dWorldGetLinearDampingThreshold#(world):"_odeWorldGetLinearDampingThreshold@4"
dWorldGetAngularDampingThreshold#(world):"_odeWorldGetAngularDampingThreshold@4"
dWorldSetLinearDampingThreshold(world,threshold#):"_odeWorldSetLinearDampingThreshold@8"
dWorldSetAngularDampingThreshold(world,threshold#):"_odeWorldSetAngularDampingThreshold@8"
dWorldGetMaxAngularSpeed#(world):"_odeWorldGetMaxAngularSpeed@4"
dWorldSetMaxAngularSpeed(world,max_speed#):"_odeWorldSetMaxAngularSpeed@8"

; ### Space Functions
dSimpleSpaceCreate%(space):"_odeSimpleSpaceCreate@4"
dHashSpaceCreate%(space):"_odeHashSpaceCreate@4"
dQuadTreeSpaceCreate%(space,cx#,cy#,cz#,ex#,ey#,ez#,depth):"_odeQuadTreeSpaceCreate@32"
dSpaceDestroy(space):"_odeSpaceDestroy@4"
dHashSpaceSetLevels(space,minlevel,maxlevel):"_odeHashSpaceSetLevels@12"
dHashSpaceGetLevels(space):"_odeHashSpaceGetLevels@4"
dSpaceSetCleanup(space,mode):"_odeSpaceSetCleanup@8"
dSpaceGetCleanup%(space):"_odeSpaceGetCleanup@4"
dSpaceAdd(space,geom):"_odeSpaceAdd@8"
dSpaceRemove(space,geom):"_odeSpaceRemove@8"
dSpaceQuery%(space,geom):"_odeSpaceQuery@8"
dSpaceGetNumGeoms%(space):"_odeSpaceGetNumGeoms@4"
dSpaceGetGeom%(space,index):"_odeSpaceGetGeom@8"
dSpaceSetSublevel(space,sublevel):"_odeSpaceSetSublevel@8"
dSpaceGetSublevel%(space):"_odeSpaceGetSublevel@4"
dSpaceGetClass%(space):"_odeSpaceGetClass@4"
dSweepAndPruneSpaceCreate%(space,axisorder):"_odeSweepAndPruneSpaceCreate@8"

; ### Rigid Body Functions
dBodyCreate%(world):"_odeBodyCreate@4"
dBodyDestroy(body):"_odeBodyDestroy@4"
dBodySetPosition(body,x#,y#,z#):"_odeBodySetPosition@16"
dBodySetRotation(body,pitch#,yaw#,roll#):"_odeBodySetRotation@16"
dBodySetQuaternion(body,qw#,qx#,qy#,qz#):"_odeBodySetQuaternion@20"
dBodySetAxisAngle(body,angle#,rx#,ry#,rz#):"_odeBodySetAxisAngle@20"
dBodySetLinearVel(body,x#,y#,z#):"_odeBodySetLinearVel@16"
dBodySetAngularVel(body,x#,y#,z#):"_odeBodySetAngularVel@16"
dBodyGetPosition(body):"_odeBodyGetPosition@4"
dBodyGetPositionX#(body):"_odeBodyGetPositionX@4"
dBodyGetPositionY#(body):"_odeBodyGetPositionY@4"
dBodyGetPositionZ#(body):"_odeBodyGetPositionZ@4"
dBodyGetRotation(body):"_odeBodyGetRotation@4"
dBodyGetQuaternion(body):"_odeBodyGetQuaternion@4"
dBodyGetAxisAngle(body):"_odeBodyGetAxisAngle@4"
dBodyGetPitch#(body):"_odeBodyGetPitch@4"
dBodyGetYaw#(body):"_odeBodyGetYaw@4"
dBodyGetRoll#(body):"_odeBodyGetRoll@4"
dBodyGetLinearVel(body):"_odeBodyGetLinearVel@4"
dBodyGetLinearVelX#(body):"_odeBodyGetLinearVelX@4"
dBodyGetLinearVelY#(body):"_odeBodyGetLinearVelY@4"
dBodyGetLinearVelZ#(body):"_odeBodyGetLinearVelZ@4"
dBodyGetAngularVel(body):"_odeBodyGetAngularVel@4"
dBodyGetAngularVelX#(body):"_odeBodyGetAngularVelX@4"
dBodyGetAngularVelY#(body):"_odeBodyGetAngularVelY@4"
dBodyGetAngularVelZ#(body):"_odeBodyGetAngularVelZ@4"
dBodySetMass(body,mass):"_odeBodySetMass@8"
dBodyGetMass#(body):"_odeBodyGetMass@4"
dBodyAddForce(body,fx#,fy#,fz#):"_odeBodyAddForce@16"
dBodyAddTorque(body,fx#,fy#,fz#):"_odeBodyAddTorque@16"
dBodyAddRelForce(body,fx#,fy#,fz#):"_odeBodyAddRelForce@16"
dBodyAddRelTorque(body,fx#,fy#,fz#):"_odeBodyAddRelTorque@16"
dBodyAddForceAtPos(body,fx#,fy#,fz#,px#,py#,pz#):"_odeBodyAddForceAtPos@28"
dBodyAddForceAtRelPos(body,fx#,fy#,fz#,px#,py#,pz#):"_odeBodyAddForceAtRelPos@28"
dBodyAddRelForceAtPos(body,fx#,fy#,fz#,px#,py#,pz#):"_odeBodyAddRelForceAtPos@28"
dBodyAddRelForceAtRelPos(body,fx#,fy#,fz#,px#,py#,pz#):"_odeBodyAddRelForceAtRelPos@28"
dBodyGetForce(body):"_odeBodyGetForce@4"
dBodyGetTorque(body):"_odeBodyGetTorque@4"
dBodySetForce(body,x#,y#,z#):"_odeBodySetForce@16"
dBodySetTorque(body,x#,y#,z#):"_odeBodySetTorque@16"
dBodyGetRelPointPos(body,px#,py#,pz#):"_odeBodyGetRelPointPos@16"
dBodyGetRelPointVel(body,px#,py#,pz#):"_odeBodyGetRelPointVel@16"
dBodyGetPointVel(body,px#,py#,pz#):"_odeBodyGetPointVel@16"
dBodyGetPosRelPoint(body,px#,py#,pz#):"_odeBodyGetPosRelPoint@16"
dBodyVectorToWorld(body,px#,py#,pz#):"_odeBodyVectorToWorld@16"
dBodyVectorFromWorld(body,px#,py#,pz#):"_odeBodyVectorFromWorld@16"
dBodyEnable(body):"_odeBodyEnable@4"
dBodyDisable(body):"_odeBodyDisable@4"
dBodyIsEnabled%(body):"_odeBodyIsEnabled@4"
dBodySetAutoDisableFlag(body,doautodisable):"_odeBodySetAutoDisableFlag@8"
dBodyGetAutoDisableFlag%(body):"_odeBodyGetAutoDisableFlag@4"
dBodySetAutoDisableLinearThreshold(body,lthreshold#):"_odeBodySetAutoDisableLinearThreshold@8"
dBodyGetAutoDisableLinearThreshold#(body):"_odeBodyGetAutoDisableLinearThreshold@4"
dBodySetAutoDisableAngularThreshold(body,athreshold#):"_odeBodySetAutoDisableAngularThreshold@8"
dBodyGetAutoDisableAngularThreshold#(body):"_odeBodyGetAutoDisableAngularThreshold@4"
dBodySetAutoDisableSteps(body,steps):"_odeBodySetAutoDisableSteps@8"
dBodyGetAutoDisableSteps%(body):"_odeBodyGetAutoDisableSteps@4"
dBodySetAutoDisableTime(body,time#):"_odeBodySetAutoDisableTime@8"
dBodyGetAutoDisableTime#(body):"_odeBodyGetAutoDisableTime@4"
dBodySetAutoDisableAverageSamplesCount(body,averagesamplescount):"_odeBodySetAutoDisableAverageSamplesCount@8"
dBodyGetAutoDisableAverageSamplesCount%(body):"_odeBodyGetAutoDisableAverageSamplesCount@4"
dBodySetAutoDisableDefaults(body):"_odeBodySetAutoDisableDefaults@4"
dBodySetData(body,data):"_odeBodySetData@8"
dBodyGetData%(body):"_odeBodyGetData@4"
dBodySetFiniteRotationMode(body,mode):"_odeBodySetFiniteRotationMode@8"
dBodyGetFiniteRotationMode%(body):"_odeBodyGetFiniteRotationMode@4"
dBodySetFiniteRotationAxis(body,x#,y#,z#):"_odeBodySetFiniteRotationAxis@16"
dBodyGetFiniteRotationAxis(body):"_odeBodyGetFiniteRotationAxis@4"
dBodyGetNumJoints%(body):"_odeBodyGetNumJoints@4"
dBodyGetJoint%(body,index):"_odeBodyGetJoint@8"
dBodyGetWorld%(body):"_odeBodyGetWorld@4"
dBodySetGravityMode(body,mode):"_odeBodySetGravityMode@8"
dBodyGetGravityMode%(body):"_odeBodyGetGravityMode@4"
dBodyGetLinearDamping#(body):"_odeBodyGetLinearDamping@4"
dBodyGetAngularDamping#(body):"_odeBodyGetAngularDamping@4"
dBodySetLinearDamping(body,scale#):"_odeBodySetLinearDamping@8"
dBodySetAngularDamping(body,scale#):"_odeBodySetAngularDamping@8"
dBodySetDamping(body,linear_scale#,angular_scale#):"_odeBodySetDamping@12"
dBodyGetLinearDampingThreshold#(body):"_odeBodyGetLinearDampingThreshold@4"
dBodyGetAngularDampingThreshold#(body):"_odeBodyGetAngularDampingThreshold@4"
dBodySetLinearDampingThreshold(body,threshold#):"_odeBodySetLinearDampingThreshold@8"
dBodySetAngularDampingThreshold(body,threshold#):"_odeBodySetAngularDampingThreshold@8"
dBodySetDampingDefaults(body):"_odeBodySetDampingDefaults@4"
dBodyGetMaxAngularSpeed#(body):"_odeBodyGetMaxAngularSpeed@4"
dBodySetMaxAngularSpeed(body,max_speed#):"_odeBodySetMaxAngularSpeed@8"
dBodyGetFirstGeom%(body):"_odeBodyGetFirstGeom@4"
dBodyGetNextGeom%(geom):"_odeBodyGetNextGeom@4"

; ### Geom Functions
dGeomDestroy(geom):"_odeGeomDestroy@4"
dGeomSetData(geom,data):"_odeGeomSetData@8"
dGeomGetData%(geom):"_odeGeomGetData@4"
dGeomSetBody(geom,body):"_odeGeomSetBody@8"
dGeomGetBody%(geom):"_odeGeomGetBody@4"
dGeomSetPosition(geom,x#,y#,z#):"_odeGeomSetPosition@16"
dGeomSetRotation(geom,pitch#,yaw#,roll#):"_odeGeomSetRotation@16"
dGeomSetQuaternion(geom,qw#,qx#,qy#,qz#):"_odeGeomSetQuaternion@20"
dGeomSetAxisAngle(geom,angle#,rx#,ry#,rz#):"_odeGeomSetAxisAngle@20"
dGeomGetPosition(geom):"_odeGeomGetPosition@4"
dGeomGetPositionX#(geom):"_odeGeomGetPositionX@4"
dGeomGetPositionY#(geom):"_odeGeomGetPositionY@4"
dGeomGetPositionZ#(geom):"_odeGeomGetPositionZ@4"
dGeomGetRotation(geom):"_odeGeomGetRotation@4"
dGeomGetQuaternion(geom):"_odeGeomGetQuaternion@4"
dGeomGetAxisAngle(geom):"_odeGeomGetAxisAngle@4"
dGeomGetPitch#(geom):"_odeGeomGetPitch@4"
dGeomGetYaw#(geom):"_odeGeomGetYaw@4"
dGeomGetRoll#(geom):"_odeGeomGetRoll@4"
dGeomGetAABBMin(geom):"_odeGeomGetAABBMin@4"
dGeomGetAABBMax(geom):"_odeGeomGetAABBMax@4"
dGeomIsSpace%(geom):"_odeGeomIsSpace@4"
dGeomGetSpace%(geom):"_odeGeomGetSpace@4"
dGeomGetClass%(geom):"_odeGeomGetClass@4"
dGeomSetCategoryBits(geom,bits):"_odeGeomSetCategoryBits@8"
dGeomSetCollideBits(geom,bits):"_odeGeomSetCollideBits@8"
dGeomGetCategoryBits%(geom):"_odeGeomGetCategoryBits@4"
dGeomGetCollideBits%(geom):"_odeGeomGetCollideBits@4"
dGeomEnable(geom):"_odeGeomEnable@4"
dGeomDisable(geom):"_odeGeomDisable@4"
dGeomIsEnabled%(geom):"_odeGeomIsEnabled@4"
dCreateSphere%(space,radius#):"_odeCreateSphere@8"
dGeomSphereSetRadius(sphere,radius#):"_odeGeomSphereSetRadius@8"
dGeomSphereGetRadius#(sphere):"_odeGeomSphereGetRadius@4"
dGeomSpherePointDepth#(sphere,x#,y#,z#):"_odeGeomSpherePointDepth@16"
dCreateBox%(space,lx#,ly#,lz#):"_odeCreateBox@16"
dGeomBoxSetLengths(box,lx#,ly#,lz#):"_odeGeomBoxSetLengths@16"
dGeomBoxGetLengths(box):"_odeGeomBoxGetLengths@4"
dGeomBoxPointDepth#(box,x#,y#,z#):"_odeGeomBoxPointDepth@16"
dCreatePlane%(space,a#,b#,c#,d#):"_odeCreatePlane@20"
dGeomPlaneSetParams(plane,a#,b#,c#,d#):"_odeGeomPlaneSetParams@20"
dGeomPlaneGetParams(plane):"_odeGeomPlaneGetParams@4"
dGeomPlanePointDepth#(plane,x#,y#,z#):"_odeGeomPlanePointDepth@16"
dCreateCylinder%(space,radius#,length#):"_odeCreateCylinder@12"
dGeomCylinderSetParams(cylinder,radius#,length#):"_odeGeomCylinderSetParams@12"
dGeomCylinderGetParams(cylinder):"_odeGeomCylinderGetParams@4"
dCreateCCylinder%(space,radius#,length#):"_odeCreateCCylinder@12"
dGeomCCylinderSetParams(ccylinder,radius#,length#):"_odeGeomCCylinderSetParams@12"
dGeomCCylinderGetParams(ccylinder):"_odeGeomCCylinderGetParams@4"
dGeomCCylinderPointDepth#(ccylinder,x#,y#,z#):"_odeGeomCCylinderPointDepth@16"
dCreateRay%(space,length#):"_odeCreateRay@8"
dGeomRaySetLength(ray,length#):"_odeGeomRaySetLength@8"
dGeomRayGetLength#(ray):"_odeGeomRayGetLength@4"
dGeomRaySet(ray,px#,py#,pz#,dx#,dy#,dz#):"_odeGeomRaySet@28"
dGeomRayGetStart(ray):"_odeGeomRayGetStart@4"
dGeomRayGetDir(ray):"_odeGeomRayGetDir@4"
dGeomTriMeshDataCreate%():"_odeGeomTriMeshDataCreate@0"
dGeomTriMeshDataDestroy(trimeshdata):"_odeGeomTriMeshDataDestroy@4"
dGeomTriMeshDataBuildSingle(trimeshdata,vertices*,vtxstride,vtxcount,indices*,idxcount,tristride):"_odeGeomTriMeshDataBuildSingle@28"
dGeomTriMeshDataBuildSingle1(trimeshdata,vertices*,vtxstride,vtxcount,indices*,idxcount,tristride,normals*):"_odeGeomTriMeshDataBuildSingle1@32"
dGeomTriMeshDataBuildSimple(trimeshdata,vertices*,vtxcount,indices*,idxcount):"_odeGeomTriMeshDataBuildSimple@20"
dCreateTriMesh%(space,trimeshdata):"_odeCreateTriMesh@8"
dCreateGeomTransform%(space):"_odeCreateGeomTransform@4"
dGeomTransformSetGeom(geoma,geomb):"_odeGeomTransformSetGeom@8"
dGeomTransformGetGeom%(geom):"_odeGeomTransformGetGeom@4"
dGeomTransformSetCleanup(geom,mode):"_odeGeomTransformSetCleanup@8"
dGeomTransformGetCleanup%(geom):"_odeGeomTransformGetCleanup@4"
dGeomTransformSetInfo(geom,mode):"_odeGeomTransformSetInfo@8"
dGeomTransformGetInfo%(geom):"_odeGeomTransformGetInfo@4"
dGeomSetOffsetPosition(geom,x#,y#,z#):"_odeGeomSetOffsetPosition@16"
dGeomSetOffsetRotation(geom,pitch#,yaw#,roll#):"_odeGeomSetOffsetRotation@16"
dGeomSetOffsetQuaternion(geom,qw#,qx#,qy#,qz#):"_odeGeomSetOffsetQuaternion@20"
dGeomSetOffsetAxisAngle(geom,angle#,rx#,ry#,rz#):"_odeGeomSetOffsetAxisAngle@20"
dGeomSetOffsetWorldPosition(geom,x#,y#,z#):"_odeGeomSetOffsetWorldPosition@16"
dGeomSetOffsetWorldRotation(geom,pitch#,yaw#,roll#):"_odeGeomSetOffsetWorldRotation@16"
dGeomSetOffsetWorldQuaternion(geom,qw#,qx#,qy#,qz#):"_odeGeomSetOffsetWorldQuaternion@20"
dGeomSetOffsetWorldAxisAngle(geom,angle#,rx#,ry#,rz#):"_odeGeomSetOffsetWorldAxisAngle@20"
dGeomClearOffset(geom):"_odeGeomClearOffset@4"
dGeomIsOffset%(geom):"_odeGeomIsOffset@4"
dGeomGetOffsetPosition(geom):"_odeGeomGetOffsetPosition@4"
dGeomGetOffsetRotation(geom):"_odeGeomGetOffsetRotation@4"
dGeomGetOffsetQuaternion(geom):"_odeGeomGetOffsetQuaternion@4"
dGeomGetOffsetAxisAngle(geom):"_odeGeomGetOffsetAxisAngle@4"
dCreateCapsule%(space,radius#,length#):"_odeCreateCapsule@12"
dGeomCapsuleSetParams(capsule,radius#,length#):"_odeGeomCapsuleSetParams@12"
dGeomCapsuleGetParams(capsule):"_odeGeomCapsuleGetParams@4"
dGeomCapsulePointDepth#(capsule,x#,y#,z#):"_odeGeomCapsulePointDepth@16"
dCreateHeightfield%(space,heightdata,bplaceable):"_odeCreateHeightfield@12"
dGeomHeightfieldDataCreate%():"_odeGeomHeightfieldDataCreate@0"
dGeomHeightfieldDataDestroy(heightdata):"_odeGeomHeightfieldDataDestroy@4"
dGeomHeightfieldDataBuildSingle(heightdata,pheightdata*,bcopyheightdata,width#,depth#,widthsamples,depthsamples,scale#,offset#,thickness#,bwrap):"_odeGeomHeightfieldDataBuildSingle@44"
dGeomHeightfieldDataSetBounds(heightdata,minheight#,maxheight#):"_odeGeomHeightfieldDataSetBounds@12"
dGeomHeightfieldSetHeightfieldData(geom,heightdata):"_odeGeomHeightfieldSetHeightfieldData@8"
dGeomHeightfieldGetHeightfieldData%(geom):"_odeGeomHeightfieldGetHeightfieldData@4"
dCreateConvex%(space,planes*,planecount,points*,pointcount,polygons*):"_odeCreateConvex@24"
dGeomSetConvex(geom,planes*,planecount,points*,pointcount,polygons*):"_odeGeomSetConvex@24"

; ### Joint Functions
dJointCreateBall%(world,group):"_odeJointCreateBall@8"
dJointSetBallAnchor(joint,x#,y#,z#):"_odeJointSetBallAnchor@16"
dJointSetBallAnchor2(joint,x#,y#,z#):"_odeJointSetBallAnchor2@16"
dJointSetBallParam(joint,param,value#):"_odeJointSetBallParam@12"
dJointGetBallAnchor(joint):"_odeJointGetBallAnchor@4"
dJointGetBallAnchor2(joint):"_odeJointGetBallAnchor2@4"
dJointGetBallParam#(joint,param):"_odeJointGetBallParam@8"
dJointCreateHinge%(world,group):"_odeJointCreateHinge@8"
dJointSetHingeAnchor(joint,x#,y#,z#):"_odeJointSetHingeAnchor@16"
dJointSetHingeAnchorDelta(joint,x#,y#,z#,ax#,ay#,az#):"_odeJointSetHingeAnchorDelta@28"
dJointSetHingeAxis(joint,x#,y#,z#):"_odeJointSetHingeAxis@16"
dJointSetHingeAxisOffset(joint,x#,y#,z#,angle#):"_odeJointSetHingeAxisOffset@20"
dJointSetHingeParam(joint,param,value#):"_odeJointSetHingeParam@12"
dJointAddHingeTorque(joint,torque#):"_odeJointAddHingeTorque@8"
dJointGetHingeAnchor(joint):"_odeJointGetHingeAnchor@4"
dJointGetHingeAnchor2(joint):"_odeJointGetHingeAnchor2@4"
dJointGetHingeAxis(joint):"_odeJointGetHingeAxis@4"
dJointGetHingeAngle#(joint):"_odeJointGetHingeAngle@4"
dJointGetHingeAngleRate#(joint):"_odeJointGetHingeAngleRate@4"
dJointGetHingeParam#(joint,param):"_odeJointGetHingeParam@8"
dJointCreateSlider%(world,group):"_odeJointCreateSlider@8"
dJointSetSliderAxis(joint,x#,y#,z#):"_odeJointSetSliderAxis@16"
dJointSetSliderAxisDelta(joint,x#,y#,z#,ax#,ay#,az#):"_odeJointSetSliderAxisDelta@28"
dJointSetSliderParam(joint,param,value#):"_odeJointSetSliderParam@12"
dJointAddSliderForce(joint,force#):"_odeJointAddSliderForce@8"
dJointGetSliderAxis(joint):"_odeJointGetSliderAxis@4"
dJointGetSliderPosition#(joint):"_odeJointGetSliderPosition@4"
dJointGetSliderPositionRate#(joint):"_odeJointGetSliderPositionRate@4"
dJointGetSliderParam#(joint,param):"_odeJointGetSliderParam@8"
dJointCreateUniversal%(world,group):"_odeJointCreateUniversal@8"
dJointSetUniversalAnchor(joint,x#,y#,z#):"_odeJointSetUniversalAnchor@16"
dJointSetUniversalAxis1(joint,x#,y#,z#):"_odeJointSetUniversalAxis1@16"
dJointSetUniversalAxis2(joint,x#,y#,z#):"_odeJointSetUniversalAxis2@16"
dJointSetUniversalParam(joint,param,value#):"_odeJointSetUniversalParam@12"
dJointAddUniversalTorques(joint,torque1#,torque2#):"_odeJointAddUniversalTorques@12"
dJointGetUniversalAnchor(joint):"_odeJointGetUniversalAnchor@4"
dJointGetUniversalAnchor2(joint):"_odeJointGetUniversalAnchor2@4"
dJointGetUniversalAxis1(joint):"_odeJointGetUniversalAxis1@4"
dJointGetUniversalAxis2(joint):"_odeJointGetUniversalAxis2@4"
dJointGetUniversalAngles(joint):"_odeJointGetUniversalAngles@4"
dJointGetUniversalAngle1#(joint):"_odeJointGetUniversalAngle1@4"
dJointGetUniversalAngle2#(joint):"_odeJointGetUniversalAngle2@4"
dJointGetUniversalAngle1Rate#(joint):"_odeJointGetUniversalAngle1Rate@4"
dJointGetUniversalAngle2Rate#(joint):"_odeJointGetUniversalAngle2Rate@4"
dJointGetUniversalParam#(joint,param):"_odeJointGetUniversalParam@8"
dJointCreateHinge2%(world,group):"_odeJointCreateHinge2@8"
dJointSetHinge2Anchor(joint,x#,y#,z#):"_odeJointSetHinge2Anchor@16"
dJointSetHinge2Axis1(joint,x#,y#,z#):"_odeJointSetHinge2Axis1@16"
dJointSetHinge2Axis2(joint,x#,y#,z#):"_odeJointSetHinge2Axis2@16"
dJointSetHinge2Param(joint,param,value#):"_odeJointSetHinge2Param@12"
dJointAddHinge2Torques(joint,torque1#,torque2#):"_odeJointAddHinge2Torques@12"
dJointGetHinge2Anchor(joint):"_odeJointGetHinge2Anchor@4"
dJointGetHinge2Anchor2(joint):"_odeJointGetHinge2Anchor2@4"
dJointGetHinge2Axis1(joint):"_odeJointGetHinge2Axis1@4"
dJointGetHinge2Axis2(joint):"_odeJointGetHinge2Axis2@4"
dJointGetHinge2Angle1#(joint):"_odeJointGetHinge2Angle1@4"
dJointGetHinge2Angle1Rate#(joint):"_odeJointGetHinge2Angle1Rate@4"
dJointGetHinge2Angle2Rate#(joint):"_odeJointGetHinge2Angle2Rate@4"
dJointGetHinge2Param#(joint,param):"_odeJointGetHinge2Param@8"
dJointCreateFixed%(world,group):"_odeJointCreateFixed@8"
dJointSetFixed(joint):"_odeJointSetFixed@4"
dJointSetFixedParam(joint,param,value#):"_odeJointSetFixedParam@12"
dJointGetFixedParam#(joint,param):"_odeJointGetFixedParam@8"
dJointCreateAMotor%(world,group):"_odeJointCreateAMotor@8"
dJointSetAMotorMode(joint,mode):"_odeJointSetAMotorMode@8"
dJointSetAMotorNumAxes(joint,num):"_odeJointSetAMotorNumAxes@8"
dJointSetAMotorAxis(joint,num,rel,x#,y#,z#):"_odeJointSetAMotorAxis@24"
dJointSetAMotorAngle(joint,num,angle#):"_odeJointSetAMotorAngle@12"
dJointSetAMotorParam(joint,param,value#):"_odeJointSetAMotorParam@12"
dJointAddAMotorTorques(joint,torque0#,torque1#,torque2#):"_odeJointAddAMotorTorques@16"
dJointGetAMotorMode%(joint):"_odeJointGetAMotorMode@4"
dJointGetAMotorNumAxes%(joint):"_odeJointGetAMotorNumAxes@4"
dJointGetAMotorAxis(joint,num):"_odeJointGetAMotorAxis@8"
dJointGetAMotorAxisRel%(joint,num):"_odeJointGetAMotorAxisRel@8"
dJointGetAMotorAngle#(joint,num):"_odeJointGetAMotorAngle@8"
dJointGetAMotorAngleRate#(joint,num):"_odeJointGetAMotorAngleRate@8"
dJointGetAMotorParam#(joint,param):"_odeJointGetAMotorParam@8"
dJointDestroy(joint):"_odeJointDestroy@4"
dJointGroupCreate%(maxsize):"_odeJointGroupCreate@4"
dJointGroupDestroy(group):"_odeJointGroupDestroy@4"
dJointGroupEmpty(group):"_odeJointGroupEmpty@4"
dJointAttach(joint,body1,body2):"_odeJointAttach@12"
dJointSetData(joint,data):"_odeJointSetData@8"
dJointGetData%(joint):"_odeJointGetData@4"
dJointGetType%(joint):"_odeJointGetType@4"
dJointGetBody%(joint,index):"_odeJointGetBody@8"
dJointFeedbackEnable(joint):"_odeJointFeedbackEnable@4"
dJointFeedbackDisable(joint):"_odeJointFeedbackDisable@4"
dJointFeedbackIsEnabled%(joint):"_odeJointFeedbackIsEnabled@4"
dJointSetFeedback(joint,feedback):"_odeJointSetFeedback@8"
dJointGetFeedbackForce1(joint):"_odeJointGetFeedbackForce1@4"
dJointGetFeedbackTorque1(joint):"_odeJointGetFeedbackTorque1@4"
dJointGetFeedbackForce2(joint):"_odeJointGetFeedbackForce2@4"
dJointGetFeedbackTorque2(joint):"_odeJointGetFeedbackTorque2@4"
dAreConnected%(body1,body2):"_odeAreConnected@8"
dAreConnectedExcluding%(body1,body2,jointtype):"_odeAreConnectedExcluding@12"
dConnectingJoint%(body1,body2):"_odeConnectingJoint@8"
dJointCreateLMotor%(world,group):"_odeJointCreateLMotor@8"
dJointSetLMotorNumAxes(joint,num):"_odeJointSetLMotorNumAxes@8"
dJointSetLMotorAxis(joint,anum,rel,x#,y#,z#):"_odeJointSetLMotorAxis@24"
dJointSetLMotorParam(joint,parameter,value#):"_odeJointSetLMotorParam@12"
dJointGetLMotorNumAxes%(joint):"_odeJointGetLMotorNumAxes@4"
dJointGetLMotorAxis(joint,anum):"_odeJointGetLMotorAxis@8"
dJointGetLMotorParam#(joint,parameter):"_odeJointGetLMotorParam@8"
dJointCreatePlane2D%(world,group):"_odeJointCreatePlane2D@8"
dJointSetPlane2DXParam(joint,parameter,value#):"_odeJointSetPlane2DXParam@12"
dJointSetPlane2DYParam(joint,parameter,value#):"_odeJointSetPlane2DYParam@12"
dJointSetPlane2DAngleParam(joint,parameter,value#):"_odeJointSetPlane2DAngleParam@12"
dJointCreatePR%(world,group):"_odeJointCreatePR@8"
dJointSetPRAnchor(joint,x#,y#,z#):"_odeJointSetPRAnchor@16"
dJointSetPRAxis1(joint,x#,y#,z#):"_odeJointSetPRAxis1@16"
dJointSetPRAxis2(joint,x#,y#,z#):"_odeJointSetPRAxis2@16"
dJointSetPRParam(joint,parameter,value#):"_odeJointSetPRParam@12"
dJointAddPRTorque(joint,torque#):"_odeJointAddPRTorque@8"
dJointGetPRAnchor(joint):"_odeJointGetPRAnchor@4"
dJointGetPRPosition#(joint):"_odeJointGetPRPosition@4"
dJointGetPRPositionRate#(joint):"_odeJointGetPRPositionRate@4"
dJointGetPRAxis1(joint):"_odeJointGetPRAxis1@4"
dJointGetPRAxis2(joint):"_odeJointGetPRAxis2@4"
dJointGetPRParam#(joint,parameter):"_odeJointGetPRParam@8"
dJointGetNumBodies%(joint):"_odeJointGetNumBodies@4"
dJointCreatePU%(world,group):"_odeJointCreatePU@8"
dJointSetPUAnchor(joint,x#,y#,z#):"_odeJointSetPUAnchor@16"
dJointSetPUAnchorDelta(joint,x#,y#,z#,dx#,dy#,dz#):"_odeJointSetPUAnchorDelta@28"
dJointSetPUAxis1(joint,x#,y#,z#):"_odeJointSetPUAxis1@16"
dJointSetPUAxis2(joint,x#,y#,z#):"_odeJointSetPUAxis2@16"
dJointSetPUAxis3(joint,x#,y#,z#):"_odeJointSetPUAxis3@16"
dJointSetPUAxisP(joint,x#,y#,z#):"_odeJointSetPUAxisP@16"
dJointSetPUParam(joint,parameter,value#):"_odeJointSetPUParam@12"
dJointGetPUPosition#(joint):"_odeJointGetPUPosition@4"
dJointGetPUPositionRate#(joint):"_odeJointGetPUPositionRate@4"
dJointGetPUAnchor(joint):"_odeJointGetPUAnchor@4"
dJointGetPUAxis1(joint):"_odeJointGetPUAxis1@4"
dJointGetPUAxis2(joint):"_odeJointGetPUAxis2@4"
dJointGetPUAxis3(joint):"_odeJointGetPUAxis3@4"
dJointGetPUAxisP(joint):"_odeJointGetPUAxisP@4"
dJointGetPUAngles(joint):"_odeJointGetPUAngles@4"
dJointGetPUAngle1#(joint):"_odeJointGetPUAngle1@4"
dJointGetPUAngle2#(joint):"_odeJointGetPUAngle2@4"
dJointGetPUAngle1Rate#(joint):"_odeJointGetPUAngle1Rate@4"
dJointGetPUAngle2Rate#(joint):"_odeJointGetPUAngle2Rate@4"
dJointGetPUParam#(joint,parameter):"_odeJointGetPUParam@8"
dJointCreatePiston%(world,group):"_odeJointCreatePiston@8"
dJointSetPistonAnchor(joint,x#,y#,z#):"_odeJointSetPistonAnchor@16"
dJointSetPistonAnchorOffset(joint,x#,y#,z#,dx#,dy#,dz#):"_odeJointSetPistonAnchorOffset@28"
dJointSetPistonAxis(joint,x#,y#,z#):"_odeJointSetPistonAxis@16"
dJointSetPistonParam(joint,parameter,value#):"_odeJointSetPistonParam@12"
dJointGetPistonAnchor(joint):"_odeJointGetPistonAnchor@4"
dJointGetPistonAnchor2(joint):"_odeJointGetPistonAnchor2@4"
dJointGetPistonAxis(joint):"_odeJointGetPistonAxis@4"
dJointGetPistonPosition#(joint):"_odeJointGetPistonPosition@4"
dJointGetPistonPositionRate#(joint):"_odeJointGetPistonPositionRate@4"
dJointGetPistonAngle#(joint):"_odeJointGetPistonAngle@4"
dJointGetPistonAngleRate#(joint):"_odeJointGetPistonAngleRate@4"
dJointAddPistonForce(joint,force#):"_odeJointAddPistonForce@8"
dJointGetPistonParam#(joint,parameter):"_odeJointGetPistonParam@8"

; ### Mass Functions
dMassCreate%():"_odeMassCreate@0"
dMassDestroy(mass):"_odeMassDestroy@4"
dMassSetZero(mass):"_odeMassSetZero@4"
dMassSetParameters(mass,themass#,cgx#,cgy#,cgz#,I11#,I22#,I33#,I12#,I13#,I23#):"_odeMassSetParameters@44"
dMassSetSphere(mass,density#,radius#):"_odeMassSetSphere@12"
dMassSetSphereTotal(mass,totalmass#,radius#):"_odeMassSetSphereTotal@12"
dMassSetCappedCylinder(mass,density#,direction,radius#,length#):"_odeMassSetCappedCylinder@20"
dMassSetCappedCylinderTotal(mass,totalmass#,direction,radius#,length#):"_odeMassSetCappedCylinderTotal@20"
dMassSetCylinder(mass,density#,direction,radius#,length#):"_odeMassSetCylinder@20"
dMassSetCylinderTotal(mass,totalmass#,direction,radius#,length#):"_odeMassSetCylinderTotal@20"
dMassSetBox(mass,density#,lx#,ly#,lz#):"_odeMassSetBox@20"
dMassSetBoxTotal(mass,totalmass#,lx#,ly#,lz#):"_odeMassSetBoxTotal@20"
dMassSetTriMesh(mass,density#,geom):"_odeMassSetTriMesh@12"
dMassSetTriMeshTotal(mass,totalmass#,geom):"_odeMassSetTriMeshTotal@12"
dMassAdjust(mass,newmass#):"_odeMassAdjust@8"
dMassTranslate(mass,x#,y#,z#):"_odeMassTranslate@16"
dMassRotate(mass,pitch#,yaw#,roll#):"_odeMassRotate@16"
dMassRotateQuaternion(mass,qw#,qx#,qy#,qz#):"_odeMassRotateQuaternion@20"
dMassRotateAxisAngle(mass,angle#,rx#,ry#,rz#):"_odeMassRotateAxisAngle@20"
dMassAdd(massa,massb):"_odeMassAdd@8"
dMassCenter(mass):"_odeMassCenter@4"
dMassSetCapsule(mass,density#,direction,radius#,length#):"_odeMassSetCapsule@20"
dMassSetCapsuleTotal(mass,totalmass#,direction,radius#,length#):"_odeMassSetCapsuleTotal@20"

; ### Collision Detection Functions
dSpaceCollide(space,world,group):"_odeSpaceCollide@12"
dSpaceCollide2(geom1,geom2,world,group):"_odeSpaceCollide2@16"

; ### Internal Collision Functions (Unique JV-ODE Functions)
dSetInternalSpaceCollideMode(mode):"_odeSetInternalSpaceCollideMode@4"
dGetInternalSpaceCollideMode%():"_odeGetInternalSpaceCollideMode@0"
dSetInternalContactSurfaceMode(mode):"_odeSetInternalContactSurfaceMode@4"
dGetInternalContactSurfaceMode%():"_odeGetInternalContactSurfaceMode@0"

; ### Contact Functions (Unique JV-ODE Functions)
dContactSetMaxContacts(max):"_odeContactSetMaxContacts@4"
dContactGetMaxContacts%():"_odeContactGetMaxContacts@0"
dContactSetMode(mode):"_odeContactSetMode@4"
dContactGetMode%():"_odeContactGetMode@0"
dContactSetMu(mu#):"_odeContactSetMu@4"
dContactGetMu#():"_odeContactGetMu@0"
dContactSetMu2(mu#):"_odeContactSetMu2@4"
dContactGetMu2#():"_odeContactGetMu2@0"
dContactSetFDir1(fdir1x#,fdir1y#,fdir1z#):"_odeContactSetFDir1@12"
dContactGetFDir1():"_odeContactGetFDir1@0"
dContactSetBounce(bounce#):"_odeContactSetBounce@4"
dContactGetBounce#():"_odeContactGetBounce@0"
dContactSetBounceVel(vel#):"_odeContactSetBounceVel@4"
dContactGetBounceVel#():"_odeContactGetBounceVel@0"
dContactSetSoftERP(erp#):"_odeContactSetSoftERP@4"
dContactGetSoftERP#():"_odeContactGetSoftERP@0"
dContactSetSoftCFM(cfm#):"_odeContactSetSoftCFM@4"
dContactGetSoftCFM#():"_odeContactGetSoftCFM@0"
dContactSetMotion1(motion#):"_odeContactSetMotion1@4"
dContactGetMotion1#():"_odeContactGetMotion1@0"
dContactSetMotion2(motion#):"_odeContactSetMotion2@4"
dContactGetMotion2#():"_odeContactGetMotion2@0"
dContactSetSlip1(slip#):"_odeContactSetSlip1@4"
dContactGetSlip1#():"_odeContactGetSlip1@0"
dContactSetSlip2(slip#):"_odeContactSetSlip2@4"
dContactGetSlip2#():"_odeContactGetSlip2@0"

; ### Geom Contact Functions (Unique JV-ODE Functions)
dGeomContactSetMode(geom,mode):"_odeGeomContactSetMode@8"
dGeomContactGetMode%(geom):"_odeGeomContactGetMode@4"
dGeomContactSetMu(geom,mu#):"_odeGeomContactSetMu@8"
dGeomContactGetMu#(geom):"_odeGeomContactGetMu@4"
dGeomContactSetMu2(geom,mu#):"_odeGeomContactSetMu2@8"
dGeomContactGetMu2#(geom):"_odeGeomContactGetMu2@4"
dGeomContactSetFDir1(geom,fdir1x#,fdir1y#,fdir1z#):"_odeGeomContactSetFDir1@16"
dGeomContactGetFDir1(geom):"_odeGeomContactGetFDir1@4"
dGeomContactSetBounce(geom,bounce#):"_odeGeomContactSetBounce@8"
dGeomContactGetBounce#(geom):"_odeGeomContactGetBounce@4"
dGeomContactSetBounceVel(geom,vel#):"_odeGeomContactSetBounceVel@8"
dGeomContactGetBounceVel#(geom):"_odeGeomContactGetBounceVel@4"
dGeomContactSetSoftERP(geom,erp#):"_odeGeomContactSetSoftERP@8"
dGeomContactGetSoftERP#(geom):"_odeGeomContactGetSoftERP@4"
dGeomContactSetSoftCFM(geom,cfm#):"_odeGeomContactSetSoftCFM@8"
dGeomContactGetSoftCFM#(geom):"_odeGeomContactGetSoftCFM@4"
dGeomContactSetMotion1(geom,motion#):"_odeGeomContactSetMotion1@8"
dGeomContactGetMotion1#(geom):"_odeGeomContactGetMotion1@4"
dGeomContactSetMotion2(geom,motion#):"_odeGeomContactSetMotion2@8"
dGeomContactGetMotion2#(geom):"_odeGeomContactGetMotion2@4"
dGeomContactSetSlip1(geom,slip#):"_odeGeomContactSetSlip1@8"
dGeomContactGetSlip1#(geom):"_odeGeomContactGetSlip1@4"
dGeomContactSetSlip2(geom,slip#):"_odeGeomContactSetSlip2@8"
dGeomContactGetSlip2#(geom):"_odeGeomContactGetSlip2@4"
dGeomContactSetDefaults(geom):"_odeGeomContactSetDefaults@4"

; ### Geom Collision Functions (Unique JV-ODE Functions)
dGeom1CountCollisions%(geom):"_odeGeom1CountCollisions@4"
dGeom1CollisionGeom%(geom,index):"_odeGeom1CollisionGeom@8"
dGeom1CollisionX#(geom,index):"_odeGeom1CollisionX@8"
dGeom1CollisionY#(geom,index):"_odeGeom1CollisionY@8"
dGeom1CollisionZ#(geom,index):"_odeGeom1CollisionZ@8"
dGeom1CollisionNX#(geom,index):"_odeGeom1CollisionNX@8"
dGeom1CollisionNY#(geom,index):"_odeGeom1CollisionNY@8"
dGeom1CollisionNZ#(geom,index):"_odeGeom1CollisionNZ@8"
dGeom1CollisionDepth#(geom,index):"_odeGeom1CollisionDepth@8"
dGeom2CountCollisions%(geom):"_odeGeom2CountCollisions@4"
dGeom2CollisionGeom%(geom,index):"_odeGeom2CollisionGeom@8"
dGeom2CollisionX#(geom,index):"_odeGeom2CollisionX@8"
dGeom2CollisionY#(geom,index):"_odeGeom2CollisionY@8"
dGeom2CollisionZ#(geom,index):"_odeGeom2CollisionZ@8"
dGeom2CollisionNX#(geom,index):"_odeGeom2CollisionNX@8"
dGeom2CollisionNY#(geom,index):"_odeGeom2CollisionNY@8"
dGeom2CollisionNZ#(geom,index):"_odeGeom2CollisionNZ@8"
dGeom2CollisionDepth#(geom,index):"_odeGeom2CollisionDepth@8"

; ### Vector Functions (Unique JV-ODE Functions)
dVectorW#():"_odeVectorW@0"
dVectorX#():"_odeVectorX@0"
dVectorY#():"_odeVectorY@0"
dVectorZ#():"_odeVectorZ@0"

; ### Misc Functions (Unique JV-ODE Functions)
dGetVersion#():"_odeGetVersion@0"
dRegisterODE(key1,key2,key3,key4):"_odeRegisterODE@16"
