/*
###################################################################################################################
JV-ODE 'C' Include

Code by Jim Williams (VIP3R)

Devious Codeworks - Copyright  2008
###################################################################################################################
*/

HINSTANCE hDLL = LoadLibrary("JV-ODE.dll");

// ### World Functions
typedef void(WINAPI *JVODE_DLL_dInitODE) ();
JVODE_DLL_dInitODE dInitODE = (JVODE_DLL_dInitODE)GetProcAddress(hDLL,"_odeInitODE@0");
typedef void(WINAPI *JVODE_DLL_dInitODE2) (int initflags);
JVODE_DLL_dInitODE2 dInitODE2 = (JVODE_DLL_dInitODE2)GetProcAddress(hDLL,"_odeInitODE2@4");
typedef int(WINAPI *JVODE_DLL_dAllocateODEDataForThread) (int allocateflags);
JVODE_DLL_dAllocateODEDataForThread dAllocateODEDataForThread = (JVODE_DLL_dAllocateODEDataForThread)GetProcAddress(hDLL,"_odeAllocateODEDataForThread@4");
typedef void(WINAPI *JVODE_DLL_dCleanupODEAllDataForThread) ();
JVODE_DLL_dCleanupODEAllDataForThread dCleanupODEAllDataForThread = (JVODE_DLL_dCleanupODEAllDataForThread)GetProcAddress(hDLL,"_odeCleanupODEAllDataForThread@0");
typedef int(WINAPI *JVODE_DLL_dWorldCreate) ();
JVODE_DLL_dWorldCreate dWorldCreate = (JVODE_DLL_dWorldCreate)GetProcAddress(hDLL,"_odeWorldCreate@0");
typedef void(WINAPI *JVODE_DLL_dWorldDestroy) (int world);
JVODE_DLL_dWorldDestroy dWorldDestroy = (JVODE_DLL_dWorldDestroy)GetProcAddress(hDLL,"_odeWorldDestroy@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetGravity) (int world, float x, float y, float z);
JVODE_DLL_dWorldSetGravity dWorldSetGravity = (JVODE_DLL_dWorldSetGravity)GetProcAddress(hDLL,"_odeWorldSetGravity@16");
typedef void(WINAPI *JVODE_DLL_dWorldGetGravity) (int world);
JVODE_DLL_dWorldGetGravity dWorldGetGravity = (JVODE_DLL_dWorldGetGravity)GetProcAddress(hDLL,"_odeWorldGetGravity@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetERP) (int world, float erp);
JVODE_DLL_dWorldSetERP dWorldSetERP = (JVODE_DLL_dWorldSetERP)GetProcAddress(hDLL,"_odeWorldSetERP@8");
typedef float(WINAPI *JVODE_DLL_dWorldGetERP) (int world);
JVODE_DLL_dWorldGetERP dWorldGetERP = (JVODE_DLL_dWorldGetERP)GetProcAddress(hDLL,"_odeWorldGetERP@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetCFM) (int world, float cfm);
JVODE_DLL_dWorldSetCFM dWorldSetCFM = (JVODE_DLL_dWorldSetCFM)GetProcAddress(hDLL,"_odeWorldSetCFM@8");
typedef float(WINAPI *JVODE_DLL_dWorldGetCFM) (int world);
JVODE_DLL_dWorldGetCFM dWorldGetCFM = (JVODE_DLL_dWorldGetCFM)GetProcAddress(hDLL,"_odeWorldGetCFM@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetAutoDisableFlag) (int world, int doautodisable);
JVODE_DLL_dWorldSetAutoDisableFlag dWorldSetAutoDisableFlag = (JVODE_DLL_dWorldSetAutoDisableFlag)GetProcAddress(hDLL,"_odeWorldSetAutoDisableFlag@8");
typedef int(WINAPI *JVODE_DLL_dWorldGetAutoDisableFlag) (int world);
JVODE_DLL_dWorldGetAutoDisableFlag dWorldGetAutoDisableFlag = (JVODE_DLL_dWorldGetAutoDisableFlag)GetProcAddress(hDLL,"_odeWorldGetAutoDisableFlag@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetAutoDisableLinearThreshold) (int world, float lthreshold);
JVODE_DLL_dWorldSetAutoDisableLinearThreshold dWorldSetAutoDisableLinearThreshold = (JVODE_DLL_dWorldSetAutoDisableLinearThreshold)GetProcAddress(hDLL,"_odeWorldSetAutoDisableLinearThreshold@8");
typedef float(WINAPI *JVODE_DLL_dWorldGetAutoDisableLinearThreshold) (int world);
JVODE_DLL_dWorldGetAutoDisableLinearThreshold dWorldGetAutoDisableLinearThreshold = (JVODE_DLL_dWorldGetAutoDisableLinearThreshold)GetProcAddress(hDLL,"_odeWorldGetAutoDisableLinearThreshold@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetAutoDisableAngularThreshold) (int world, float athreshold);
JVODE_DLL_dWorldSetAutoDisableAngularThreshold dWorldSetAutoDisableAngularThreshold = (JVODE_DLL_dWorldSetAutoDisableAngularThreshold)GetProcAddress(hDLL,"_odeWorldSetAutoDisableAngularThreshold@8");
typedef float(WINAPI *JVODE_DLL_dWorldGetAutoDisableAngularThreshold) (int world);
JVODE_DLL_dWorldGetAutoDisableAngularThreshold dWorldGetAutoDisableAngularThreshold = (JVODE_DLL_dWorldGetAutoDisableAngularThreshold)GetProcAddress(hDLL,"_odeWorldGetAutoDisableAngularThreshold@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetAutoDisableSteps) (int world, int steps);
JVODE_DLL_dWorldSetAutoDisableSteps dWorldSetAutoDisableSteps = (JVODE_DLL_dWorldSetAutoDisableSteps)GetProcAddress(hDLL,"_odeWorldSetAutoDisableSteps@8");
typedef int(WINAPI *JVODE_DLL_dWorldGetAutoDisableSteps) (int world);
JVODE_DLL_dWorldGetAutoDisableSteps dWorldGetAutoDisableSteps = (JVODE_DLL_dWorldGetAutoDisableSteps)GetProcAddress(hDLL,"_odeWorldGetAutoDisableSteps@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetAutoDisableTime) (int world, float time);
JVODE_DLL_dWorldSetAutoDisableTime dWorldSetAutoDisableTime = (JVODE_DLL_dWorldSetAutoDisableTime)GetProcAddress(hDLL,"_odeWorldSetAutoDisableTime@8");
typedef float(WINAPI *JVODE_DLL_dWorldGetAutoDisableTime) (int world);
JVODE_DLL_dWorldGetAutoDisableTime dWorldGetAutoDisableTime = (JVODE_DLL_dWorldGetAutoDisableTime)GetProcAddress(hDLL,"_odeWorldGetAutoDisableTime@4");
typedef void(WINAPI *JVODE_DLL_dWorldImpulseToForce) (int world, float stepsize, float ix, float iy, float iz);
JVODE_DLL_dWorldImpulseToForce dWorldImpulseToForce = (JVODE_DLL_dWorldImpulseToForce)GetProcAddress(hDLL,"_odeWorldImpulseToForce@20");
typedef void(WINAPI *JVODE_DLL_dCloseODE) ();
JVODE_DLL_dCloseODE dCloseODE = (JVODE_DLL_dCloseODE)GetProcAddress(hDLL,"_odeCloseODE@0");
typedef void(WINAPI *JVODE_DLL_dWorldStep) (int world, float stepsize);
JVODE_DLL_dWorldStep dWorldStep = (JVODE_DLL_dWorldStep)GetProcAddress(hDLL,"_odeWorldStep@8");
typedef void(WINAPI *JVODE_DLL_dWorldQuickStep) (int world, float stepsize);
JVODE_DLL_dWorldQuickStep dWorldQuickStep = (JVODE_DLL_dWorldQuickStep)GetProcAddress(hDLL,"_odeWorldQuickStep@8");
typedef void(WINAPI *JVODE_DLL_dWorldSetQuickStepNumIterations) (int world, int num);
JVODE_DLL_dWorldSetQuickStepNumIterations dWorldSetQuickStepNumIterations = (JVODE_DLL_dWorldSetQuickStepNumIterations)GetProcAddress(hDLL,"_odeWorldSetQuickStepNumIterations@8");
typedef int(WINAPI *JVODE_DLL_dWorldGetQuickStepNumIterations) (int world);
JVODE_DLL_dWorldGetQuickStepNumIterations dWorldGetQuickStepNumIterations = (JVODE_DLL_dWorldGetQuickStepNumIterations)GetProcAddress(hDLL,"_odeWorldGetQuickStepNumIterations@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetContactMaxCorrectingVel) (int world, float vel);
JVODE_DLL_dWorldSetContactMaxCorrectingVel dWorldSetContactMaxCorrectingVel = (JVODE_DLL_dWorldSetContactMaxCorrectingVel)GetProcAddress(hDLL,"_odeWorldSetContactMaxCorrectingVel@8");
typedef float(WINAPI *JVODE_DLL_dWorldGetContactMaxCorrectingVel) (int world);
JVODE_DLL_dWorldGetContactMaxCorrectingVel dWorldGetContactMaxCorrectingVel = (JVODE_DLL_dWorldGetContactMaxCorrectingVel)GetProcAddress(hDLL,"_odeWorldGetContactMaxCorrectingVel@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetContactSurfaceLayer) (int world, float depth);
JVODE_DLL_dWorldSetContactSurfaceLayer dWorldSetContactSurfaceLayer = (JVODE_DLL_dWorldSetContactSurfaceLayer)GetProcAddress(hDLL,"_odeWorldSetContactSurfaceLayer@8");
typedef float(WINAPI *JVODE_DLL_dWorldGetContactSurfaceLayer) (int world);
JVODE_DLL_dWorldGetContactSurfaceLayer dWorldGetContactSurfaceLayer = (JVODE_DLL_dWorldGetContactSurfaceLayer)GetProcAddress(hDLL,"_odeWorldGetContactSurfaceLayer@4");
typedef void(WINAPI *JVODE_DLL_dWorldStepFast1) (int world, float stepsize, int maxiterations);
JVODE_DLL_dWorldStepFast1 dWorldStepFast1 = (JVODE_DLL_dWorldStepFast1)GetProcAddress(hDLL,"_odeWorldStepFast1@12");
typedef void(WINAPI *JVODE_DLL_dWorldSetAutoEnableDepthSF1) (int world, int autoenabledepth);
JVODE_DLL_dWorldSetAutoEnableDepthSF1 dWorldSetAutoEnableDepthSF1 = (JVODE_DLL_dWorldSetAutoEnableDepthSF1)GetProcAddress(hDLL,"_odeWorldSetAutoEnableDepthSF1@8");
typedef int(WINAPI *JVODE_DLL_dWorldGetAutoEnableDepthSF1) (int world);
JVODE_DLL_dWorldGetAutoEnableDepthSF1 dWorldGetAutoEnableDepthSF1 = (JVODE_DLL_dWorldGetAutoEnableDepthSF1)GetProcAddress(hDLL,"_odeWorldGetAutoEnableDepthSF1@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetQuickStepW) (int world, float overrelaxation);
JVODE_DLL_dWorldSetQuickStepW dWorldSetQuickStepW = (JVODE_DLL_dWorldSetQuickStepW)GetProcAddress(hDLL,"_odeWorldSetQuickStepW@8");
typedef float(WINAPI *JVODE_DLL_dWorldGetQuickStepW) (int world);
JVODE_DLL_dWorldGetQuickStepW dWorldGetQuickStepW = (JVODE_DLL_dWorldGetQuickStepW)GetProcAddress(hDLL,"_odeWorldGetQuickStepW@4");
typedef float(WINAPI *JVODE_DLL_dWorldGetLinearDamping) (int world);
JVODE_DLL_dWorldGetLinearDamping dWorldGetLinearDamping = (JVODE_DLL_dWorldGetLinearDamping)GetProcAddress(hDLL,"_odeWorldGetLinearDamping@4");
typedef float(WINAPI *JVODE_DLL_dWorldGetAngularDamping) (int world);
JVODE_DLL_dWorldGetAngularDamping dWorldGetAngularDamping = (JVODE_DLL_dWorldGetAngularDamping)GetProcAddress(hDLL,"_odeWorldGetAngularDamping@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetLinearDamping) (int world, float scale);
JVODE_DLL_dWorldSetLinearDamping dWorldSetLinearDamping = (JVODE_DLL_dWorldSetLinearDamping)GetProcAddress(hDLL,"_odeWorldSetLinearDamping@8");
typedef void(WINAPI *JVODE_DLL_dWorldSetAngularDamping) (int world, float scale);
JVODE_DLL_dWorldSetAngularDamping dWorldSetAngularDamping = (JVODE_DLL_dWorldSetAngularDamping)GetProcAddress(hDLL,"_odeWorldSetAngularDamping@8");
typedef void(WINAPI *JVODE_DLL_dWorldSetDamping) (int world, float linear_scale, float angular_scale);
JVODE_DLL_dWorldSetDamping dWorldSetDamping = (JVODE_DLL_dWorldSetDamping)GetProcAddress(hDLL,"_odeWorldSetDamping@12");
typedef float(WINAPI *JVODE_DLL_dWorldGetLinearDampingThreshold) (int world);
JVODE_DLL_dWorldGetLinearDampingThreshold dWorldGetLinearDampingThreshold = (JVODE_DLL_dWorldGetLinearDampingThreshold)GetProcAddress(hDLL,"_odeWorldGetLinearDampingThreshold@4");
typedef float(WINAPI *JVODE_DLL_dWorldGetAngularDampingThreshold) (int world);
JVODE_DLL_dWorldGetAngularDampingThreshold dWorldGetAngularDampingThreshold = (JVODE_DLL_dWorldGetAngularDampingThreshold)GetProcAddress(hDLL,"_odeWorldGetAngularDampingThreshold@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetLinearDampingThreshold) (int world, float threshold);
JVODE_DLL_dWorldSetLinearDampingThreshold dWorldSetLinearDampingThreshold = (JVODE_DLL_dWorldSetLinearDampingThreshold)GetProcAddress(hDLL,"_odeWorldSetLinearDampingThreshold@8");
typedef void(WINAPI *JVODE_DLL_dWorldSetAngularDampingThreshold) (int world, float threshold);
JVODE_DLL_dWorldSetAngularDampingThreshold dWorldSetAngularDampingThreshold = (JVODE_DLL_dWorldSetAngularDampingThreshold)GetProcAddress(hDLL,"_odeWorldSetAngularDampingThreshold@8");
typedef float(WINAPI *JVODE_DLL_dWorldGetMaxAngularSpeed) (int world);
JVODE_DLL_dWorldGetMaxAngularSpeed dWorldGetMaxAngularSpeed = (JVODE_DLL_dWorldGetMaxAngularSpeed)GetProcAddress(hDLL,"_odeWorldGetMaxAngularSpeed@4");
typedef void(WINAPI *JVODE_DLL_dWorldSetMaxAngularSpeed) (int world, float max_speed);
JVODE_DLL_dWorldSetMaxAngularSpeed dWorldSetMaxAngularSpeed = (JVODE_DLL_dWorldSetMaxAngularSpeed)GetProcAddress(hDLL,"_odeWorldSetMaxAngularSpeed@8");

// ### Space Functions
typedef int(WINAPI *JVODE_DLL_dSimpleSpaceCreate) (int space);
JVODE_DLL_dSimpleSpaceCreate dSimpleSpaceCreate = (JVODE_DLL_dSimpleSpaceCreate)GetProcAddress(hDLL,"_odeSimpleSpaceCreate@4");
typedef int(WINAPI *JVODE_DLL_dHashSpaceCreate) (int space);
JVODE_DLL_dHashSpaceCreate dHashSpaceCreate = (JVODE_DLL_dHashSpaceCreate)GetProcAddress(hDLL,"_odeHashSpaceCreate@4");
typedef int(WINAPI *JVODE_DLL_dQuadTreeSpaceCreate) (int space, float cx, float cy, float cz, float ex, float ey, float ez, int depth);
JVODE_DLL_dQuadTreeSpaceCreate dQuadTreeSpaceCreate = (JVODE_DLL_dQuadTreeSpaceCreate)GetProcAddress(hDLL,"_odeQuadTreeSpaceCreate@32");
typedef void(WINAPI *JVODE_DLL_dSpaceDestroy) (int space);
JVODE_DLL_dSpaceDestroy dSpaceDestroy = (JVODE_DLL_dSpaceDestroy)GetProcAddress(hDLL,"_odeSpaceDestroy@4");
typedef void(WINAPI *JVODE_DLL_dHashSpaceSetLevels) (int space, int minlevel, int maxlevel);
JVODE_DLL_dHashSpaceSetLevels dHashSpaceSetLevels = (JVODE_DLL_dHashSpaceSetLevels)GetProcAddress(hDLL,"_odeHashSpaceSetLevels@12");
typedef void(WINAPI *JVODE_DLL_dHashSpaceGetLevels) (int space);
JVODE_DLL_dHashSpaceGetLevels dHashSpaceGetLevels = (JVODE_DLL_dHashSpaceGetLevels)GetProcAddress(hDLL,"_odeHashSpaceGetLevels@4");
typedef void(WINAPI *JVODE_DLL_dSpaceSetCleanup) (int space, int mode);
JVODE_DLL_dSpaceSetCleanup dSpaceSetCleanup = (JVODE_DLL_dSpaceSetCleanup)GetProcAddress(hDLL,"_odeSpaceSetCleanup@8");
typedef int(WINAPI *JVODE_DLL_dSpaceGetCleanup) (int space);
JVODE_DLL_dSpaceGetCleanup dSpaceGetCleanup = (JVODE_DLL_dSpaceGetCleanup)GetProcAddress(hDLL,"_odeSpaceGetCleanup@4");
typedef void(WINAPI *JVODE_DLL_dSpaceAdd) (int space, int geom);
JVODE_DLL_dSpaceAdd dSpaceAdd = (JVODE_DLL_dSpaceAdd)GetProcAddress(hDLL,"_odeSpaceAdd@8");
typedef void(WINAPI *JVODE_DLL_dSpaceRemove) (int space, int geom);
JVODE_DLL_dSpaceRemove dSpaceRemove = (JVODE_DLL_dSpaceRemove)GetProcAddress(hDLL,"_odeSpaceRemove@8");
typedef int(WINAPI *JVODE_DLL_dSpaceQuery) (int space, int geom);
JVODE_DLL_dSpaceQuery dSpaceQuery = (JVODE_DLL_dSpaceQuery)GetProcAddress(hDLL,"_odeSpaceQuery@8");
typedef int(WINAPI *JVODE_DLL_dSpaceGetNumGeoms) (int space);
JVODE_DLL_dSpaceGetNumGeoms dSpaceGetNumGeoms = (JVODE_DLL_dSpaceGetNumGeoms)GetProcAddress(hDLL,"_odeSpaceGetNumGeoms@4");
typedef int(WINAPI *JVODE_DLL_dSpaceGetGeom) (int space, int index);
JVODE_DLL_dSpaceGetGeom dSpaceGetGeom = (JVODE_DLL_dSpaceGetGeom)GetProcAddress(hDLL,"_odeSpaceGetGeom@8");
typedef void(WINAPI *JVODE_DLL_dSpaceSetSublevel) (int space, int sublevel);
JVODE_DLL_dSpaceSetSublevel dSpaceSetSublevel = (JVODE_DLL_dSpaceSetSublevel)GetProcAddress(hDLL,"_odeSpaceSetSublevel@8");
typedef int(WINAPI *JVODE_DLL_dSpaceGetSublevel) (int space);
JVODE_DLL_dSpaceGetSublevel dSpaceGetSublevel = (JVODE_DLL_dSpaceGetSublevel)GetProcAddress(hDLL,"_odeSpaceGetSublevel@4");
typedef int(WINAPI *JVODE_DLL_dSpaceGetClass) (int space);
JVODE_DLL_dSpaceGetClass dSpaceGetClass = (JVODE_DLL_dSpaceGetClass)GetProcAddress(hDLL,"_odeSpaceGetClass@4");
typedef int(WINAPI *JVODE_DLL_dSweepAndPruneSpaceCreate) (int space, int axisorder);
JVODE_DLL_dSweepAndPruneSpaceCreate dSweepAndPruneSpaceCreate = (JVODE_DLL_dSweepAndPruneSpaceCreate)GetProcAddress(hDLL,"_odeSweepAndPruneSpaceCreate@8");

// ### Rigid Body Functions
typedef int(WINAPI *JVODE_DLL_dBodyCreate) (int world);
JVODE_DLL_dBodyCreate dBodyCreate = (JVODE_DLL_dBodyCreate)GetProcAddress(hDLL,"_odeBodyCreate@4");
typedef void(WINAPI *JVODE_DLL_dBodyDestroy) (int body);
JVODE_DLL_dBodyDestroy dBodyDestroy = (JVODE_DLL_dBodyDestroy)GetProcAddress(hDLL,"_odeBodyDestroy@4");
typedef void(WINAPI *JVODE_DLL_dBodySetPosition) (int body, float x, float y, float z);
JVODE_DLL_dBodySetPosition dBodySetPosition = (JVODE_DLL_dBodySetPosition)GetProcAddress(hDLL,"_odeBodySetPosition@16");
typedef void(WINAPI *JVODE_DLL_dBodySetRotation) (int body, float pitch, float yaw, float roll);
JVODE_DLL_dBodySetRotation dBodySetRotation = (JVODE_DLL_dBodySetRotation)GetProcAddress(hDLL,"_odeBodySetRotation@16");
typedef void(WINAPI *JVODE_DLL_dBodySetQuaternion) (int body, float qw, float qx, float qy, float qz);
JVODE_DLL_dBodySetQuaternion dBodySetQuaternion = (JVODE_DLL_dBodySetQuaternion)GetProcAddress(hDLL,"_odeBodySetQuaternion@20");
typedef void(WINAPI *JVODE_DLL_dBodySetAxisAngle) (int body, float angle, float rx, float ry, float rz);
JVODE_DLL_dBodySetAxisAngle dBodySetAxisAngle = (JVODE_DLL_dBodySetAxisAngle)GetProcAddress(hDLL,"_odeBodySetAxisAngle@20");
typedef void(WINAPI *JVODE_DLL_dBodySetLinearVel) (int body, float x, float y, float z);
JVODE_DLL_dBodySetLinearVel dBodySetLinearVel = (JVODE_DLL_dBodySetLinearVel)GetProcAddress(hDLL,"_odeBodySetLinearVel@16");
typedef void(WINAPI *JVODE_DLL_dBodySetAngularVel) (int body, float x, float y, float z);
JVODE_DLL_dBodySetAngularVel dBodySetAngularVel = (JVODE_DLL_dBodySetAngularVel)GetProcAddress(hDLL,"_odeBodySetAngularVel@16");
typedef void(WINAPI *JVODE_DLL_dBodyGetPosition) (int body);
JVODE_DLL_dBodyGetPosition dBodyGetPosition = (JVODE_DLL_dBodyGetPosition)GetProcAddress(hDLL,"_odeBodyGetPosition@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetPositionX) (int body);
JVODE_DLL_dBodyGetPositionX dBodyGetPositionX = (JVODE_DLL_dBodyGetPositionX)GetProcAddress(hDLL,"_odeBodyGetPositionX@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetPositionY) (int body);
JVODE_DLL_dBodyGetPositionY dBodyGetPositionY = (JVODE_DLL_dBodyGetPositionY)GetProcAddress(hDLL,"_odeBodyGetPositionY@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetPositionZ) (int body);
JVODE_DLL_dBodyGetPositionZ dBodyGetPositionZ = (JVODE_DLL_dBodyGetPositionZ)GetProcAddress(hDLL,"_odeBodyGetPositionZ@4");
typedef void(WINAPI *JVODE_DLL_dBodyGetRotation) (int body);
JVODE_DLL_dBodyGetRotation dBodyGetRotation = (JVODE_DLL_dBodyGetRotation)GetProcAddress(hDLL,"_odeBodyGetRotation@4");
typedef void(WINAPI *JVODE_DLL_dBodyGetQuaternion) (int body);
JVODE_DLL_dBodyGetQuaternion dBodyGetQuaternion = (JVODE_DLL_dBodyGetQuaternion)GetProcAddress(hDLL,"_odeBodyGetQuaternion@4");
typedef void(WINAPI *JVODE_DLL_dBodyGetAxisAngle) (int body);
JVODE_DLL_dBodyGetAxisAngle dBodyGetAxisAngle = (JVODE_DLL_dBodyGetAxisAngle)GetProcAddress(hDLL,"_odeBodyGetAxisAngle@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetPitch) (int body);
JVODE_DLL_dBodyGetPitch dBodyGetPitch = (JVODE_DLL_dBodyGetPitch)GetProcAddress(hDLL,"_odeBodyGetPitch@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetYaw) (int body);
JVODE_DLL_dBodyGetYaw dBodyGetYaw = (JVODE_DLL_dBodyGetYaw)GetProcAddress(hDLL,"_odeBodyGetYaw@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetRoll) (int body);
JVODE_DLL_dBodyGetRoll dBodyGetRoll = (JVODE_DLL_dBodyGetRoll)GetProcAddress(hDLL,"_odeBodyGetRoll@4");
typedef void(WINAPI *JVODE_DLL_dBodyGetLinearVel) (int body);
JVODE_DLL_dBodyGetLinearVel dBodyGetLinearVel = (JVODE_DLL_dBodyGetLinearVel)GetProcAddress(hDLL,"_odeBodyGetLinearVel@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetLinearVelX) (int body);
JVODE_DLL_dBodyGetLinearVelX dBodyGetLinearVelX = (JVODE_DLL_dBodyGetLinearVelX)GetProcAddress(hDLL,"_odeBodyGetLinearVelX@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetLinearVelY) (int body);
JVODE_DLL_dBodyGetLinearVelY dBodyGetLinearVelY = (JVODE_DLL_dBodyGetLinearVelY)GetProcAddress(hDLL,"_odeBodyGetLinearVelY@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetLinearVelZ) (int body);
JVODE_DLL_dBodyGetLinearVelZ dBodyGetLinearVelZ = (JVODE_DLL_dBodyGetLinearVelZ)GetProcAddress(hDLL,"_odeBodyGetLinearVelZ@4");
typedef void(WINAPI *JVODE_DLL_dBodyGetAngularVel) (int body);
JVODE_DLL_dBodyGetAngularVel dBodyGetAngularVel = (JVODE_DLL_dBodyGetAngularVel)GetProcAddress(hDLL,"_odeBodyGetAngularVel@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetAngularVelX) (int body);
JVODE_DLL_dBodyGetAngularVelX dBodyGetAngularVelX = (JVODE_DLL_dBodyGetAngularVelX)GetProcAddress(hDLL,"_odeBodyGetAngularVelX@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetAngularVelY) (int body);
JVODE_DLL_dBodyGetAngularVelY dBodyGetAngularVelY = (JVODE_DLL_dBodyGetAngularVelY)GetProcAddress(hDLL,"_odeBodyGetAngularVelY@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetAngularVelZ) (int body);
JVODE_DLL_dBodyGetAngularVelZ dBodyGetAngularVelZ = (JVODE_DLL_dBodyGetAngularVelZ)GetProcAddress(hDLL,"_odeBodyGetAngularVelZ@4");
typedef void(WINAPI *JVODE_DLL_dBodySetMass) (int body, int mass);
JVODE_DLL_dBodySetMass dBodySetMass = (JVODE_DLL_dBodySetMass)GetProcAddress(hDLL,"_odeBodySetMass@8");
typedef float(WINAPI *JVODE_DLL_dBodyGetMass) (int body);
JVODE_DLL_dBodyGetMass dBodyGetMass = (JVODE_DLL_dBodyGetMass)GetProcAddress(hDLL,"_odeBodyGetMass@4");
typedef void(WINAPI *JVODE_DLL_dBodyAddForce) (int body, float fx, float fy, float fz);
JVODE_DLL_dBodyAddForce dBodyAddForce = (JVODE_DLL_dBodyAddForce)GetProcAddress(hDLL,"_odeBodyAddForce@16");
typedef void(WINAPI *JVODE_DLL_dBodyAddTorque) (int body, float fx, float fy, float fz);
JVODE_DLL_dBodyAddTorque dBodyAddTorque = (JVODE_DLL_dBodyAddTorque)GetProcAddress(hDLL,"_odeBodyAddTorque@16");
typedef void(WINAPI *JVODE_DLL_dBodyAddRelForce) (int body, float fx, float fy, float fz);
JVODE_DLL_dBodyAddRelForce dBodyAddRelForce = (JVODE_DLL_dBodyAddRelForce)GetProcAddress(hDLL,"_odeBodyAddRelForce@16");
typedef void(WINAPI *JVODE_DLL_dBodyAddRelTorque) (int body, float fx, float fy, float fz);
JVODE_DLL_dBodyAddRelTorque dBodyAddRelTorque = (JVODE_DLL_dBodyAddRelTorque)GetProcAddress(hDLL,"_odeBodyAddRelTorque@16");
typedef void(WINAPI *JVODE_DLL_dBodyAddForceAtPos) (int body, float fx, float fy, float fz, float px, float py, float pz);
JVODE_DLL_dBodyAddForceAtPos dBodyAddForceAtPos = (JVODE_DLL_dBodyAddForceAtPos)GetProcAddress(hDLL,"_odeBodyAddForceAtPos@28");
typedef void(WINAPI *JVODE_DLL_dBodyAddForceAtRelPos) (int body, float fx, float fy, float fz, float px, float py, float pz);
JVODE_DLL_dBodyAddForceAtRelPos dBodyAddForceAtRelPos = (JVODE_DLL_dBodyAddForceAtRelPos)GetProcAddress(hDLL,"_odeBodyAddForceAtRelPos@28");
typedef void(WINAPI *JVODE_DLL_dBodyAddRelForceAtPos) (int body, float fx, float fy, float fz, float px, float py, float pz);
JVODE_DLL_dBodyAddRelForceAtPos dBodyAddRelForceAtPos = (JVODE_DLL_dBodyAddRelForceAtPos)GetProcAddress(hDLL,"_odeBodyAddRelForceAtPos@28");
typedef void(WINAPI *JVODE_DLL_dBodyAddRelForceAtRelPos) (int body, float fx, float fy, float fz, float px, float py, float pz);
JVODE_DLL_dBodyAddRelForceAtRelPos dBodyAddRelForceAtRelPos = (JVODE_DLL_dBodyAddRelForceAtRelPos)GetProcAddress(hDLL,"_odeBodyAddRelForceAtRelPos@28");
typedef void(WINAPI *JVODE_DLL_dBodyGetForce) (int body);
JVODE_DLL_dBodyGetForce dBodyGetForce = (JVODE_DLL_dBodyGetForce)GetProcAddress(hDLL,"_odeBodyGetForce@4");
typedef void(WINAPI *JVODE_DLL_dBodyGetTorque) (int body);
JVODE_DLL_dBodyGetTorque dBodyGetTorque = (JVODE_DLL_dBodyGetTorque)GetProcAddress(hDLL,"_odeBodyGetTorque@4");
typedef void(WINAPI *JVODE_DLL_dBodySetForce) (int body, float x, float y, float z);
JVODE_DLL_dBodySetForce dBodySetForce = (JVODE_DLL_dBodySetForce)GetProcAddress(hDLL,"_odeBodySetForce@16");
typedef void(WINAPI *JVODE_DLL_dBodySetTorque) (int body, float x, float y, float z);
JVODE_DLL_dBodySetTorque dBodySetTorque = (JVODE_DLL_dBodySetTorque)GetProcAddress(hDLL,"_odeBodySetTorque@16");
typedef void(WINAPI *JVODE_DLL_dBodyGetRelPointPos) (int body, float px, float py, float pz);
JVODE_DLL_dBodyGetRelPointPos dBodyGetRelPointPos = (JVODE_DLL_dBodyGetRelPointPos)GetProcAddress(hDLL,"_odeBodyGetRelPointPos@16");
typedef void(WINAPI *JVODE_DLL_dBodyGetRelPointVel) (int body, float px, float py, float pz);
JVODE_DLL_dBodyGetRelPointVel dBodyGetRelPointVel = (JVODE_DLL_dBodyGetRelPointVel)GetProcAddress(hDLL,"_odeBodyGetRelPointVel@16");
typedef void(WINAPI *JVODE_DLL_dBodyGetPointVel) (int body, float px, float py, float pz);
JVODE_DLL_dBodyGetPointVel dBodyGetPointVel = (JVODE_DLL_dBodyGetPointVel)GetProcAddress(hDLL,"_odeBodyGetPointVel@16");
typedef void(WINAPI *JVODE_DLL_dBodyGetPosRelPoint) (int body, float px, float py, float pz);
JVODE_DLL_dBodyGetPosRelPoint dBodyGetPosRelPoint = (JVODE_DLL_dBodyGetPosRelPoint)GetProcAddress(hDLL,"_odeBodyGetPosRelPoint@16");
typedef void(WINAPI *JVODE_DLL_dBodyVectorToWorld) (int body, float px, float py, float pz);
JVODE_DLL_dBodyVectorToWorld dBodyVectorToWorld = (JVODE_DLL_dBodyVectorToWorld)GetProcAddress(hDLL,"_odeBodyVectorToWorld@16");
typedef void(WINAPI *JVODE_DLL_dBodyVectorFromWorld) (int body, float px, float py, float pz);
JVODE_DLL_dBodyVectorFromWorld dBodyVectorFromWorld = (JVODE_DLL_dBodyVectorFromWorld)GetProcAddress(hDLL,"_odeBodyVectorFromWorld@16");
typedef void(WINAPI *JVODE_DLL_dBodyEnable) (int body);
JVODE_DLL_dBodyEnable dBodyEnable = (JVODE_DLL_dBodyEnable)GetProcAddress(hDLL,"_odeBodyEnable@4");
typedef void(WINAPI *JVODE_DLL_dBodyDisable) (int body);
JVODE_DLL_dBodyDisable dBodyDisable = (JVODE_DLL_dBodyDisable)GetProcAddress(hDLL,"_odeBodyDisable@4");
typedef int(WINAPI *JVODE_DLL_dBodyIsEnabled) (int body);
JVODE_DLL_dBodyIsEnabled dBodyIsEnabled = (JVODE_DLL_dBodyIsEnabled)GetProcAddress(hDLL,"_odeBodyIsEnabled@4");
typedef void(WINAPI *JVODE_DLL_dBodySetAutoDisableFlag) (int body, int doautodisable);
JVODE_DLL_dBodySetAutoDisableFlag dBodySetAutoDisableFlag = (JVODE_DLL_dBodySetAutoDisableFlag)GetProcAddress(hDLL,"_odeBodySetAutoDisableFlag@8");
typedef int(WINAPI *JVODE_DLL_dBodyGetAutoDisableFlag) (int body);
JVODE_DLL_dBodyGetAutoDisableFlag dBodyGetAutoDisableFlag = (JVODE_DLL_dBodyGetAutoDisableFlag)GetProcAddress(hDLL,"_odeBodyGetAutoDisableFlag@4");
typedef void(WINAPI *JVODE_DLL_dBodySetAutoDisableLinearThreshold) (int body, float lthreshold);
JVODE_DLL_dBodySetAutoDisableLinearThreshold dBodySetAutoDisableLinearThreshold = (JVODE_DLL_dBodySetAutoDisableLinearThreshold)GetProcAddress(hDLL,"_odeBodySetAutoDisableLinearThreshold@8");
typedef float(WINAPI *JVODE_DLL_dBodyGetAutoDisableLinearThreshold) (int body);
JVODE_DLL_dBodyGetAutoDisableLinearThreshold dBodyGetAutoDisableLinearThreshold = (JVODE_DLL_dBodyGetAutoDisableLinearThreshold)GetProcAddress(hDLL,"_odeBodyGetAutoDisableLinearThreshold@4");
typedef void(WINAPI *JVODE_DLL_dBodySetAutoDisableAngularThreshold) (int body, float athreshold);
JVODE_DLL_dBodySetAutoDisableAngularThreshold dBodySetAutoDisableAngularThreshold = (JVODE_DLL_dBodySetAutoDisableAngularThreshold)GetProcAddress(hDLL,"_odeBodySetAutoDisableAngularThreshold@8");
typedef float(WINAPI *JVODE_DLL_dBodyGetAutoDisableAngularThreshold) (int body);
JVODE_DLL_dBodyGetAutoDisableAngularThreshold dBodyGetAutoDisableAngularThreshold = (JVODE_DLL_dBodyGetAutoDisableAngularThreshold)GetProcAddress(hDLL,"_odeBodyGetAutoDisableAngularThreshold@4");
typedef void(WINAPI *JVODE_DLL_dBodySetAutoDisableSteps) (int body, int steps);
JVODE_DLL_dBodySetAutoDisableSteps dBodySetAutoDisableSteps = (JVODE_DLL_dBodySetAutoDisableSteps)GetProcAddress(hDLL,"_odeBodySetAutoDisableSteps@8");
typedef int(WINAPI *JVODE_DLL_dBodyGetAutoDisableSteps) (int body);
JVODE_DLL_dBodyGetAutoDisableSteps dBodyGetAutoDisableSteps = (JVODE_DLL_dBodyGetAutoDisableSteps)GetProcAddress(hDLL,"_odeBodyGetAutoDisableSteps@4");
typedef void(WINAPI *JVODE_DLL_dBodySetAutoDisableTime) (int body, float time);
JVODE_DLL_dBodySetAutoDisableTime dBodySetAutoDisableTime = (JVODE_DLL_dBodySetAutoDisableTime)GetProcAddress(hDLL,"_odeBodySetAutoDisableTime@8");
typedef float(WINAPI *JVODE_DLL_dBodyGetAutoDisableTime) (int body);
JVODE_DLL_dBodyGetAutoDisableTime dBodyGetAutoDisableTime = (JVODE_DLL_dBodyGetAutoDisableTime)GetProcAddress(hDLL,"_odeBodyGetAutoDisableTime@4");
typedef void(WINAPI *JVODE_DLL_dBodySetAutoDisableAverageSamplesCount) (int body, int averagesamplescount);
JVODE_DLL_dBodySetAutoDisableAverageSamplesCount dBodySetAutoDisableAverageSamplesCount = (JVODE_DLL_dBodySetAutoDisableAverageSamplesCount)GetProcAddress(hDLL,"_odeBodySetAutoDisableAverageSamplesCount@8");
typedef int(WINAPI *JVODE_DLL_dBodyGetAutoDisableAverageSamplesCount) (int body);
JVODE_DLL_dBodyGetAutoDisableAverageSamplesCount dBodyGetAutoDisableAverageSamplesCount = (JVODE_DLL_dBodyGetAutoDisableAverageSamplesCount)GetProcAddress(hDLL,"_odeBodyGetAutoDisableAverageSamplesCount@4");
typedef void(WINAPI *JVODE_DLL_dBodySetAutoDisableDefaults) (int body);
JVODE_DLL_dBodySetAutoDisableDefaults dBodySetAutoDisableDefaults = (JVODE_DLL_dBodySetAutoDisableDefaults)GetProcAddress(hDLL,"_odeBodySetAutoDisableDefaults@4");
typedef void(WINAPI *JVODE_DLL_dBodySetData) (int body, int data);
JVODE_DLL_dBodySetData dBodySetData = (JVODE_DLL_dBodySetData)GetProcAddress(hDLL,"_odeBodySetData@8");
typedef int(WINAPI *JVODE_DLL_dBodyGetData) (int body);
JVODE_DLL_dBodyGetData dBodyGetData = (JVODE_DLL_dBodyGetData)GetProcAddress(hDLL,"_odeBodyGetData@4");
typedef void(WINAPI *JVODE_DLL_dBodySetFiniteRotationMode) (int body, int mode);
JVODE_DLL_dBodySetFiniteRotationMode dBodySetFiniteRotationMode = (JVODE_DLL_dBodySetFiniteRotationMode)GetProcAddress(hDLL,"_odeBodySetFiniteRotationMode@8");
typedef int(WINAPI *JVODE_DLL_dBodyGetFiniteRotationMode) (int body);
JVODE_DLL_dBodyGetFiniteRotationMode dBodyGetFiniteRotationMode = (JVODE_DLL_dBodyGetFiniteRotationMode)GetProcAddress(hDLL,"_odeBodyGetFiniteRotationMode@4");
typedef void(WINAPI *JVODE_DLL_dBodySetFiniteRotationAxis) (int body, float x, float y, float z);
JVODE_DLL_dBodySetFiniteRotationAxis dBodySetFiniteRotationAxis = (JVODE_DLL_dBodySetFiniteRotationAxis)GetProcAddress(hDLL,"_odeBodySetFiniteRotationAxis@16");
typedef void(WINAPI *JVODE_DLL_dBodyGetFiniteRotationAxis) (int body);
JVODE_DLL_dBodyGetFiniteRotationAxis dBodyGetFiniteRotationAxis = (JVODE_DLL_dBodyGetFiniteRotationAxis)GetProcAddress(hDLL,"_odeBodyGetFiniteRotationAxis@4");
typedef int(WINAPI *JVODE_DLL_dBodyGetNumJoints) (int body);
JVODE_DLL_dBodyGetNumJoints dBodyGetNumJoints = (JVODE_DLL_dBodyGetNumJoints)GetProcAddress(hDLL,"_odeBodyGetNumJoints@4");
typedef int(WINAPI *JVODE_DLL_dBodyGetJoint) (int body, int index);
JVODE_DLL_dBodyGetJoint dBodyGetJoint = (JVODE_DLL_dBodyGetJoint)GetProcAddress(hDLL,"_odeBodyGetJoint@8");
typedef int(WINAPI *JVODE_DLL_dBodyGetWorld) (int body);
JVODE_DLL_dBodyGetWorld dBodyGetWorld = (JVODE_DLL_dBodyGetWorld)GetProcAddress(hDLL,"_odeBodyGetWorld@4");
typedef void(WINAPI *JVODE_DLL_dBodySetGravityMode) (int body, int mode);
JVODE_DLL_dBodySetGravityMode dBodySetGravityMode = (JVODE_DLL_dBodySetGravityMode)GetProcAddress(hDLL,"_odeBodySetGravityMode@8");
typedef int(WINAPI *JVODE_DLL_dBodyGetGravityMode) (int body);
JVODE_DLL_dBodyGetGravityMode dBodyGetGravityMode = (JVODE_DLL_dBodyGetGravityMode)GetProcAddress(hDLL,"_odeBodyGetGravityMode@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetLinearDamping) (int body);
JVODE_DLL_dBodyGetLinearDamping dBodyGetLinearDamping = (JVODE_DLL_dBodyGetLinearDamping)GetProcAddress(hDLL,"_odeBodyGetLinearDamping@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetAngularDamping) (int body);
JVODE_DLL_dBodyGetAngularDamping dBodyGetAngularDamping = (JVODE_DLL_dBodyGetAngularDamping)GetProcAddress(hDLL,"_odeBodyGetAngularDamping@4");
typedef void(WINAPI *JVODE_DLL_dBodySetLinearDamping) (int body, float scale);
JVODE_DLL_dBodySetLinearDamping dBodySetLinearDamping = (JVODE_DLL_dBodySetLinearDamping)GetProcAddress(hDLL,"_odeBodySetLinearDamping@8");
typedef void(WINAPI *JVODE_DLL_dBodySetAngularDamping) (int body, float scale);
JVODE_DLL_dBodySetAngularDamping dBodySetAngularDamping = (JVODE_DLL_dBodySetAngularDamping)GetProcAddress(hDLL,"_odeBodySetAngularDamping@8");
typedef void(WINAPI *JVODE_DLL_dBodySetDamping) (int body, float linear_scale, float angular_scale);
JVODE_DLL_dBodySetDamping dBodySetDamping = (JVODE_DLL_dBodySetDamping)GetProcAddress(hDLL,"_odeBodySetDamping@12");
typedef float(WINAPI *JVODE_DLL_dBodyGetLinearDampingThreshold) (int body);
JVODE_DLL_dBodyGetLinearDampingThreshold dBodyGetLinearDampingThreshold = (JVODE_DLL_dBodyGetLinearDampingThreshold)GetProcAddress(hDLL,"_odeBodyGetLinearDampingThreshold@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetAngularDampingThreshold) (int body);
JVODE_DLL_dBodyGetAngularDampingThreshold dBodyGetAngularDampingThreshold = (JVODE_DLL_dBodyGetAngularDampingThreshold)GetProcAddress(hDLL,"_odeBodyGetAngularDampingThreshold@4");
typedef void(WINAPI *JVODE_DLL_dBodySetLinearDampingThreshold) (int body, float threshold);
JVODE_DLL_dBodySetLinearDampingThreshold dBodySetLinearDampingThreshold = (JVODE_DLL_dBodySetLinearDampingThreshold)GetProcAddress(hDLL,"_odeBodySetLinearDampingThreshold@8");
typedef void(WINAPI *JVODE_DLL_dBodySetAngularDampingThreshold) (int body, float threshold);
JVODE_DLL_dBodySetAngularDampingThreshold dBodySetAngularDampingThreshold = (JVODE_DLL_dBodySetAngularDampingThreshold)GetProcAddress(hDLL,"_odeBodySetAngularDampingThreshold@8");
typedef void(WINAPI *JVODE_DLL_dBodySetDampingDefaults) (int body);
JVODE_DLL_dBodySetDampingDefaults dBodySetDampingDefaults = (JVODE_DLL_dBodySetDampingDefaults)GetProcAddress(hDLL,"_odeBodySetDampingDefaults@4");
typedef float(WINAPI *JVODE_DLL_dBodyGetMaxAngularSpeed) (int body);
JVODE_DLL_dBodyGetMaxAngularSpeed dBodyGetMaxAngularSpeed = (JVODE_DLL_dBodyGetMaxAngularSpeed)GetProcAddress(hDLL,"_odeBodyGetMaxAngularSpeed@4");
typedef void(WINAPI *JVODE_DLL_dBodySetMaxAngularSpeed) (int body, float max_speed);
JVODE_DLL_dBodySetMaxAngularSpeed dBodySetMaxAngularSpeed = (JVODE_DLL_dBodySetMaxAngularSpeed)GetProcAddress(hDLL,"_odeBodySetMaxAngularSpeed@8");
typedef int(WINAPI *JVODE_DLL_dBodyGetFirstGeom) (int body);
JVODE_DLL_dBodyGetFirstGeom dBodyGetFirstGeom = (JVODE_DLL_dBodyGetFirstGeom)GetProcAddress(hDLL,"_odeBodyGetFirstGeom@4");
typedef int(WINAPI *JVODE_DLL_dBodyGetNextGeom) (int geom);
JVODE_DLL_dBodyGetNextGeom dBodyGetNextGeom = (JVODE_DLL_dBodyGetNextGeom)GetProcAddress(hDLL,"_odeBodyGetNextGeom@4");

// ### Geom Functions
typedef void(WINAPI *JVODE_DLL_dGeomDestroy) (int geom);
JVODE_DLL_dGeomDestroy dGeomDestroy = (JVODE_DLL_dGeomDestroy)GetProcAddress(hDLL,"_odeGeomDestroy@4");
typedef void(WINAPI *JVODE_DLL_dGeomSetData) (int geom, int data);
JVODE_DLL_dGeomSetData dGeomSetData = (JVODE_DLL_dGeomSetData)GetProcAddress(hDLL,"_odeGeomSetData@8");
typedef int(WINAPI *JVODE_DLL_dGeomGetData) (int geom);
JVODE_DLL_dGeomGetData dGeomGetData = (JVODE_DLL_dGeomGetData)GetProcAddress(hDLL,"_odeGeomGetData@4");
typedef void(WINAPI *JVODE_DLL_dGeomSetBody) (int geom, int body);
JVODE_DLL_dGeomSetBody dGeomSetBody = (JVODE_DLL_dGeomSetBody)GetProcAddress(hDLL,"_odeGeomSetBody@8");
typedef int(WINAPI *JVODE_DLL_dGeomGetBody) (int geom);
JVODE_DLL_dGeomGetBody dGeomGetBody = (JVODE_DLL_dGeomGetBody)GetProcAddress(hDLL,"_odeGeomGetBody@4");
typedef void(WINAPI *JVODE_DLL_dGeomSetPosition) (int geom, float x, float y, float z);
JVODE_DLL_dGeomSetPosition dGeomSetPosition = (JVODE_DLL_dGeomSetPosition)GetProcAddress(hDLL,"_odeGeomSetPosition@16");
typedef void(WINAPI *JVODE_DLL_dGeomSetRotation) (int geom, float pitch, float yaw, float roll);
JVODE_DLL_dGeomSetRotation dGeomSetRotation = (JVODE_DLL_dGeomSetRotation)GetProcAddress(hDLL,"_odeGeomSetRotation@16");
typedef void(WINAPI *JVODE_DLL_dGeomSetQuaternion) (int geom, float qw, float qx, float qy, float qz);
JVODE_DLL_dGeomSetQuaternion dGeomSetQuaternion = (JVODE_DLL_dGeomSetQuaternion)GetProcAddress(hDLL,"_odeGeomSetQuaternion@20");
typedef void(WINAPI *JVODE_DLL_dGeomSetAxisAngle) (int geom, float angle, float rx, float ry, float rz);
JVODE_DLL_dGeomSetAxisAngle dGeomSetAxisAngle = (JVODE_DLL_dGeomSetAxisAngle)GetProcAddress(hDLL,"_odeGeomSetAxisAngle@20");
typedef void(WINAPI *JVODE_DLL_dGeomGetPosition) (int geom);
JVODE_DLL_dGeomGetPosition dGeomGetPosition = (JVODE_DLL_dGeomGetPosition)GetProcAddress(hDLL,"_odeGeomGetPosition@4");
typedef float(WINAPI *JVODE_DLL_dGeomGetPositionX) (int geom);
JVODE_DLL_dGeomGetPositionX dGeomGetPositionX = (JVODE_DLL_dGeomGetPositionX)GetProcAddress(hDLL,"_odeGeomGetPositionX@4");
typedef float(WINAPI *JVODE_DLL_dGeomGetPositionY) (int geom);
JVODE_DLL_dGeomGetPositionY dGeomGetPositionY = (JVODE_DLL_dGeomGetPositionY)GetProcAddress(hDLL,"_odeGeomGetPositionY@4");
typedef float(WINAPI *JVODE_DLL_dGeomGetPositionZ) (int geom);
JVODE_DLL_dGeomGetPositionZ dGeomGetPositionZ = (JVODE_DLL_dGeomGetPositionZ)GetProcAddress(hDLL,"_odeGeomGetPositionZ@4");
typedef void(WINAPI *JVODE_DLL_dGeomGetRotation) (int geom);
JVODE_DLL_dGeomGetRotation dGeomGetRotation = (JVODE_DLL_dGeomGetRotation)GetProcAddress(hDLL,"_odeGeomGetRotation@4");
typedef void(WINAPI *JVODE_DLL_dGeomGetQuaternion) (int geom);
JVODE_DLL_dGeomGetQuaternion dGeomGetQuaternion = (JVODE_DLL_dGeomGetQuaternion)GetProcAddress(hDLL,"_odeGeomGetQuaternion@4");
typedef void(WINAPI *JVODE_DLL_dGeomGetAxisAngle) (int geom);
JVODE_DLL_dGeomGetAxisAngle dGeomGetAxisAngle = (JVODE_DLL_dGeomGetAxisAngle)GetProcAddress(hDLL,"_odeGeomGetAxisAngle@4");
typedef float(WINAPI *JVODE_DLL_dGeomGetPitch) (int geom);
JVODE_DLL_dGeomGetPitch dGeomGetPitch = (JVODE_DLL_dGeomGetPitch)GetProcAddress(hDLL,"_odeGeomGetPitch@4");
typedef float(WINAPI *JVODE_DLL_dGeomGetYaw) (int geom);
JVODE_DLL_dGeomGetYaw dGeomGetYaw = (JVODE_DLL_dGeomGetYaw)GetProcAddress(hDLL,"_odeGeomGetYaw@4");
typedef float(WINAPI *JVODE_DLL_dGeomGetRoll) (int geom);
JVODE_DLL_dGeomGetRoll dGeomGetRoll = (JVODE_DLL_dGeomGetRoll)GetProcAddress(hDLL,"_odeGeomGetRoll@4");
typedef void(WINAPI *JVODE_DLL_dGeomGetAABBMin) (int geom);
JVODE_DLL_dGeomGetAABBMin dGeomGetAABBMin = (JVODE_DLL_dGeomGetAABBMin)GetProcAddress(hDLL,"_odeGeomGetAABBMin@4");
typedef void(WINAPI *JVODE_DLL_dGeomGetAABBMax) (int geom);
JVODE_DLL_dGeomGetAABBMax dGeomGetAABBMax = (JVODE_DLL_dGeomGetAABBMax)GetProcAddress(hDLL,"_odeGeomGetAABBMax@4");
typedef int(WINAPI *JVODE_DLL_dGeomIsSpace) (int geom);
JVODE_DLL_dGeomIsSpace dGeomIsSpace = (JVODE_DLL_dGeomIsSpace)GetProcAddress(hDLL,"_odeGeomIsSpace@4");
typedef int(WINAPI *JVODE_DLL_dGeomGetSpace) (int geom);
JVODE_DLL_dGeomGetSpace dGeomGetSpace = (JVODE_DLL_dGeomGetSpace)GetProcAddress(hDLL,"_odeGeomGetSpace@4");
typedef int(WINAPI *JVODE_DLL_dGeomGetClass) (int geom);
JVODE_DLL_dGeomGetClass dGeomGetClass = (JVODE_DLL_dGeomGetClass)GetProcAddress(hDLL,"_odeGeomGetClass@4");
typedef void(WINAPI *JVODE_DLL_dGeomSetCategoryBits) (int geom, int bits);
JVODE_DLL_dGeomSetCategoryBits dGeomSetCategoryBits = (JVODE_DLL_dGeomSetCategoryBits)GetProcAddress(hDLL,"_odeGeomSetCategoryBits@8");
typedef void(WINAPI *JVODE_DLL_dGeomSetCollideBits) (int geom, int bits);
JVODE_DLL_dGeomSetCollideBits dGeomSetCollideBits = (JVODE_DLL_dGeomSetCollideBits)GetProcAddress(hDLL,"_odeGeomSetCollideBits@8");
typedef int(WINAPI *JVODE_DLL_dGeomGetCategoryBits) (int geom);
JVODE_DLL_dGeomGetCategoryBits dGeomGetCategoryBits = (JVODE_DLL_dGeomGetCategoryBits)GetProcAddress(hDLL,"_odeGeomGetCategoryBits@4");
typedef int(WINAPI *JVODE_DLL_dGeomGetCollideBits) (int geom);
JVODE_DLL_dGeomGetCollideBits dGeomGetCollideBits = (JVODE_DLL_dGeomGetCollideBits)GetProcAddress(hDLL,"_odeGeomGetCollideBits@4");
typedef void(WINAPI *JVODE_DLL_dGeomEnable) (int geom);
JVODE_DLL_dGeomEnable dGeomEnable = (JVODE_DLL_dGeomEnable)GetProcAddress(hDLL,"_odeGeomEnable@4");
typedef void(WINAPI *JVODE_DLL_dGeomDisable) (int geom);
JVODE_DLL_dGeomDisable dGeomDisable = (JVODE_DLL_dGeomDisable)GetProcAddress(hDLL,"_odeGeomDisable@4");
typedef int(WINAPI *JVODE_DLL_dGeomIsEnabled) (int geom);
JVODE_DLL_dGeomIsEnabled dGeomIsEnabled = (JVODE_DLL_dGeomIsEnabled)GetProcAddress(hDLL,"_odeGeomIsEnabled@4");
typedef int(WINAPI *JVODE_DLL_dCreateSphere) (int space, float radius);
JVODE_DLL_dCreateSphere dCreateSphere = (JVODE_DLL_dCreateSphere)GetProcAddress(hDLL,"_odeCreateSphere@8");
typedef void(WINAPI *JVODE_DLL_dGeomSphereSetRadius) (int sphere, float radius);
JVODE_DLL_dGeomSphereSetRadius dGeomSphereSetRadius = (JVODE_DLL_dGeomSphereSetRadius)GetProcAddress(hDLL,"_odeGeomSphereSetRadius@8");
typedef float(WINAPI *JVODE_DLL_dGeomSphereGetRadius) (int sphere);
JVODE_DLL_dGeomSphereGetRadius dGeomSphereGetRadius = (JVODE_DLL_dGeomSphereGetRadius)GetProcAddress(hDLL,"_odeGeomSphereGetRadius@4");
typedef float(WINAPI *JVODE_DLL_dGeomSpherePointDepth) (int sphere, float x, float y, float z);
JVODE_DLL_dGeomSpherePointDepth dGeomSpherePointDepth = (JVODE_DLL_dGeomSpherePointDepth)GetProcAddress(hDLL,"_odeGeomSpherePointDepth@16");
typedef int(WINAPI *JVODE_DLL_dCreateBox) (int space, float lx, float ly, float lz);
JVODE_DLL_dCreateBox dCreateBox = (JVODE_DLL_dCreateBox)GetProcAddress(hDLL,"_odeCreateBox@16");
typedef void(WINAPI *JVODE_DLL_dGeomBoxSetLengths) (int box, float lx, float ly, float lz);
JVODE_DLL_dGeomBoxSetLengths dGeomBoxSetLengths = (JVODE_DLL_dGeomBoxSetLengths)GetProcAddress(hDLL,"_odeGeomBoxSetLengths@16");
typedef void(WINAPI *JVODE_DLL_dGeomBoxGetLengths) (int box);
JVODE_DLL_dGeomBoxGetLengths dGeomBoxGetLengths = (JVODE_DLL_dGeomBoxGetLengths)GetProcAddress(hDLL,"_odeGeomBoxGetLengths@4");
typedef float(WINAPI *JVODE_DLL_dGeomBoxPointDepth) (int box, float x, float y, float z);
JVODE_DLL_dGeomBoxPointDepth dGeomBoxPointDepth = (JVODE_DLL_dGeomBoxPointDepth)GetProcAddress(hDLL,"_odeGeomBoxPointDepth@16");
typedef int(WINAPI *JVODE_DLL_dCreatePlane) (int space, float a, float b, float c, float d);
JVODE_DLL_dCreatePlane dCreatePlane = (JVODE_DLL_dCreatePlane)GetProcAddress(hDLL,"_odeCreatePlane@20");
typedef void(WINAPI *JVODE_DLL_dGeomPlaneSetParams) (int plane, float a, float b, float c, float d);
JVODE_DLL_dGeomPlaneSetParams dGeomPlaneSetParams = (JVODE_DLL_dGeomPlaneSetParams)GetProcAddress(hDLL,"_odeGeomPlaneSetParams@20");
typedef void(WINAPI *JVODE_DLL_dGeomPlaneGetParams) (int plane);
JVODE_DLL_dGeomPlaneGetParams dGeomPlaneGetParams = (JVODE_DLL_dGeomPlaneGetParams)GetProcAddress(hDLL,"_odeGeomPlaneGetParams@4");
typedef float(WINAPI *JVODE_DLL_dGeomPlanePointDepth) (int plane, float x, float y, float z);
JVODE_DLL_dGeomPlanePointDepth dGeomPlanePointDepth = (JVODE_DLL_dGeomPlanePointDepth)GetProcAddress(hDLL,"_odeGeomPlanePointDepth@16");
typedef int(WINAPI *JVODE_DLL_dCreateCylinder) (int space, float radius, float length);
JVODE_DLL_dCreateCylinder dCreateCylinder = (JVODE_DLL_dCreateCylinder)GetProcAddress(hDLL,"_odeCreateCylinder@12");
typedef void(WINAPI *JVODE_DLL_dGeomCylinderSetParams) (int cylinder, float radius, float length);
JVODE_DLL_dGeomCylinderSetParams dGeomCylinderSetParams = (JVODE_DLL_dGeomCylinderSetParams)GetProcAddress(hDLL,"_odeGeomCylinderSetParams@12");
typedef void(WINAPI *JVODE_DLL_dGeomCylinderGetParams) (int cylinder);
JVODE_DLL_dGeomCylinderGetParams dGeomCylinderGetParams = (JVODE_DLL_dGeomCylinderGetParams)GetProcAddress(hDLL,"_odeGeomCylinderGetParams@4");
typedef int(WINAPI *JVODE_DLL_dCreateCCylinder) (int space, float radius, float length);
JVODE_DLL_dCreateCCylinder dCreateCCylinder = (JVODE_DLL_dCreateCCylinder)GetProcAddress(hDLL,"_odeCreateCCylinder@12");
typedef void(WINAPI *JVODE_DLL_dGeomCCylinderSetParams) (int ccylinder, float radius, float length);
JVODE_DLL_dGeomCCylinderSetParams dGeomCCylinderSetParams = (JVODE_DLL_dGeomCCylinderSetParams)GetProcAddress(hDLL,"_odeGeomCCylinderSetParams@12");
typedef void(WINAPI *JVODE_DLL_dGeomCCylinderGetParams) (int ccylinder);
JVODE_DLL_dGeomCCylinderGetParams dGeomCCylinderGetParams = (JVODE_DLL_dGeomCCylinderGetParams)GetProcAddress(hDLL,"_odeGeomCCylinderGetParams@4");
typedef float(WINAPI *JVODE_DLL_dGeomCCylinderPointDepth) (int ccylinder, float x, float y, float z);
JVODE_DLL_dGeomCCylinderPointDepth dGeomCCylinderPointDepth = (JVODE_DLL_dGeomCCylinderPointDepth)GetProcAddress(hDLL,"_odeGeomCCylinderPointDepth@16");
typedef int(WINAPI *JVODE_DLL_dCreateRay) (int space, float length);
JVODE_DLL_dCreateRay dCreateRay = (JVODE_DLL_dCreateRay)GetProcAddress(hDLL,"_odeCreateRay@8");
typedef void(WINAPI *JVODE_DLL_dGeomRaySetLength) (int ray, float length);
JVODE_DLL_dGeomRaySetLength dGeomRaySetLength = (JVODE_DLL_dGeomRaySetLength)GetProcAddress(hDLL,"_odeGeomRaySetLength@8");
typedef float(WINAPI *JVODE_DLL_dGeomRayGetLength) (int ray);
JVODE_DLL_dGeomRayGetLength dGeomRayGetLength = (JVODE_DLL_dGeomRayGetLength)GetProcAddress(hDLL,"_odeGeomRayGetLength@4");
typedef void(WINAPI *JVODE_DLL_dGeomRaySet) (int ray, float px, float py, float pz, float dx, float dy, float dz);
JVODE_DLL_dGeomRaySet dGeomRaySet = (JVODE_DLL_dGeomRaySet)GetProcAddress(hDLL,"_odeGeomRaySet@28");
typedef void(WINAPI *JVODE_DLL_dGeomRayGetStart) (int ray);
JVODE_DLL_dGeomRayGetStart dGeomRayGetStart = (JVODE_DLL_dGeomRayGetStart)GetProcAddress(hDLL,"_odeGeomRayGetStart@4");
typedef void(WINAPI *JVODE_DLL_dGeomRayGetDir) (int ray);
JVODE_DLL_dGeomRayGetDir dGeomRayGetDir = (JVODE_DLL_dGeomRayGetDir)GetProcAddress(hDLL,"_odeGeomRayGetDir@4");
typedef int(WINAPI *JVODE_DLL_dGeomTriMeshDataCreate) ();
JVODE_DLL_dGeomTriMeshDataCreate dGeomTriMeshDataCreate = (JVODE_DLL_dGeomTriMeshDataCreate)GetProcAddress(hDLL,"_odeGeomTriMeshDataCreate@0");
typedef void(WINAPI *JVODE_DLL_dGeomTriMeshDataDestroy) (int trimeshdata);
JVODE_DLL_dGeomTriMeshDataDestroy dGeomTriMeshDataDestroy = (JVODE_DLL_dGeomTriMeshDataDestroy)GetProcAddress(hDLL,"_odeGeomTriMeshDataDestroy@4");
typedef void(WINAPI *JVODE_DLL_dGeomTriMeshDataBuildSingle) (int trimeshdata, int vertices, int vtxstride, int vtxcount, int indices, int idxcount, int tristride);
JVODE_DLL_dGeomTriMeshDataBuildSingle dGeomTriMeshDataBuildSingle = (JVODE_DLL_dGeomTriMeshDataBuildSingle)GetProcAddress(hDLL,"_odeGeomTriMeshDataBuildSingle@28");
typedef void(WINAPI *JVODE_DLL_dGeomTriMeshDataBuildSingle1) (int trimeshdata, int vertices, int vtxstride, int vtxcount, int indices, int idxcount, int tristride, int normals);
JVODE_DLL_dGeomTriMeshDataBuildSingle1 dGeomTriMeshDataBuildSingle1 = (JVODE_DLL_dGeomTriMeshDataBuildSingle1)GetProcAddress(hDLL,"_odeGeomTriMeshDataBuildSingle1@32");
typedef void(WINAPI *JVODE_DLL_dGeomTriMeshDataBuildSimple) (int trimeshdata, int vertices, int vtxcount, int indices, int idxcount);
JVODE_DLL_dGeomTriMeshDataBuildSimple dGeomTriMeshDataBuildSimple = (JVODE_DLL_dGeomTriMeshDataBuildSimple)GetProcAddress(hDLL,"_odeGeomTriMeshDataBuildSimple@20");
typedef int(WINAPI *JVODE_DLL_dCreateTriMesh) (int space, int trimeshdata);
JVODE_DLL_dCreateTriMesh dCreateTriMesh = (JVODE_DLL_dCreateTriMesh)GetProcAddress(hDLL,"_odeCreateTriMesh@8");
typedef int(WINAPI *JVODE_DLL_dCreateGeomTransform) (int space);
JVODE_DLL_dCreateGeomTransform dCreateGeomTransform = (JVODE_DLL_dCreateGeomTransform)GetProcAddress(hDLL,"_odeCreateGeomTransform@4");
typedef void(WINAPI *JVODE_DLL_dGeomTransformSetGeom) (int geoma, int geomb);
JVODE_DLL_dGeomTransformSetGeom dGeomTransformSetGeom = (JVODE_DLL_dGeomTransformSetGeom)GetProcAddress(hDLL,"_odeGeomTransformSetGeom@8");
typedef int(WINAPI *JVODE_DLL_dGeomTransformGetGeom) (int geom);
JVODE_DLL_dGeomTransformGetGeom dGeomTransformGetGeom = (JVODE_DLL_dGeomTransformGetGeom)GetProcAddress(hDLL,"_odeGeomTransformGetGeom@4");
typedef void(WINAPI *JVODE_DLL_dGeomTransformSetCleanup) (int geom, int mode);
JVODE_DLL_dGeomTransformSetCleanup dGeomTransformSetCleanup = (JVODE_DLL_dGeomTransformSetCleanup)GetProcAddress(hDLL,"_odeGeomTransformSetCleanup@8");
typedef int(WINAPI *JVODE_DLL_dGeomTransformGetCleanup) (int geom);
JVODE_DLL_dGeomTransformGetCleanup dGeomTransformGetCleanup = (JVODE_DLL_dGeomTransformGetCleanup)GetProcAddress(hDLL,"_odeGeomTransformGetCleanup@4");
typedef void(WINAPI *JVODE_DLL_dGeomTransformSetInfo) (int geom, int mode);
JVODE_DLL_dGeomTransformSetInfo dGeomTransformSetInfo = (JVODE_DLL_dGeomTransformSetInfo)GetProcAddress(hDLL,"_odeGeomTransformSetInfo@8");
typedef int(WINAPI *JVODE_DLL_dGeomTransformGetInfo) (int geom);
JVODE_DLL_dGeomTransformGetInfo dGeomTransformGetInfo = (JVODE_DLL_dGeomTransformGetInfo)GetProcAddress(hDLL,"_odeGeomTransformGetInfo@4");
typedef void(WINAPI *JVODE_DLL_dGeomSetOffsetPosition) (int geom, float x, float y, float z);
JVODE_DLL_dGeomSetOffsetPosition dGeomSetOffsetPosition = (JVODE_DLL_dGeomSetOffsetPosition)GetProcAddress(hDLL,"_odeGeomSetOffsetPosition@16");
typedef void(WINAPI *JVODE_DLL_dGeomSetOffsetRotation) (int geom, float pitch, float yaw, float roll);
JVODE_DLL_dGeomSetOffsetRotation dGeomSetOffsetRotation = (JVODE_DLL_dGeomSetOffsetRotation)GetProcAddress(hDLL,"_odeGeomSetOffsetRotation@16");
typedef void(WINAPI *JVODE_DLL_dGeomSetOffsetQuaternion) (int geom, float qw, float qx, float qy, float qz);
JVODE_DLL_dGeomSetOffsetQuaternion dGeomSetOffsetQuaternion = (JVODE_DLL_dGeomSetOffsetQuaternion)GetProcAddress(hDLL,"_odeGeomSetOffsetQuaternion@20");
typedef void(WINAPI *JVODE_DLL_dGeomSetOffsetAxisAngle) (int geom, float angle, float rx, float ry, float rz);
JVODE_DLL_dGeomSetOffsetAxisAngle dGeomSetOffsetAxisAngle = (JVODE_DLL_dGeomSetOffsetAxisAngle)GetProcAddress(hDLL,"_odeGeomSetOffsetAxisAngle@20");
typedef void(WINAPI *JVODE_DLL_dGeomSetOffsetWorldPosition) (int geom, float x, float y, float z);
JVODE_DLL_dGeomSetOffsetWorldPosition dGeomSetOffsetWorldPosition = (JVODE_DLL_dGeomSetOffsetWorldPosition)GetProcAddress(hDLL,"_odeGeomSetOffsetWorldPosition@16");
typedef void(WINAPI *JVODE_DLL_dGeomSetOffsetWorldRotation) (int geom, float pitch, float yaw, float roll);
JVODE_DLL_dGeomSetOffsetWorldRotation dGeomSetOffsetWorldRotation = (JVODE_DLL_dGeomSetOffsetWorldRotation)GetProcAddress(hDLL,"_odeGeomSetOffsetWorldRotation@16");
typedef void(WINAPI *JVODE_DLL_dGeomSetOffsetWorldQuaternion) (int geom, float qw, float qx, float qy, float qz);
JVODE_DLL_dGeomSetOffsetWorldQuaternion dGeomSetOffsetWorldQuaternion = (JVODE_DLL_dGeomSetOffsetWorldQuaternion)GetProcAddress(hDLL,"_odeGeomSetOffsetWorldQuaternion@20");
typedef void(WINAPI *JVODE_DLL_dGeomSetOffsetWorldAxisAngle) (int geom, float angle, float rx, float ry, float rz);
JVODE_DLL_dGeomSetOffsetWorldAxisAngle dGeomSetOffsetWorldAxisAngle = (JVODE_DLL_dGeomSetOffsetWorldAxisAngle)GetProcAddress(hDLL,"_odeGeomSetOffsetWorldAxisAngle@20");
typedef void(WINAPI *JVODE_DLL_dGeomClearOffset) (int geom);
JVODE_DLL_dGeomClearOffset dGeomClearOffset = (JVODE_DLL_dGeomClearOffset)GetProcAddress(hDLL,"_odeGeomClearOffset@4");
typedef int(WINAPI *JVODE_DLL_dGeomIsOffset) (int geom);
JVODE_DLL_dGeomIsOffset dGeomIsOffset = (JVODE_DLL_dGeomIsOffset)GetProcAddress(hDLL,"_odeGeomIsOffset@4");
typedef void(WINAPI *JVODE_DLL_dGeomGetOffsetPosition) (int geom);
JVODE_DLL_dGeomGetOffsetPosition dGeomGetOffsetPosition = (JVODE_DLL_dGeomGetOffsetPosition)GetProcAddress(hDLL,"_odeGeomGetOffsetPosition@4");
typedef void(WINAPI *JVODE_DLL_dGeomGetOffsetRotation) (int geom);
JVODE_DLL_dGeomGetOffsetRotation dGeomGetOffsetRotation = (JVODE_DLL_dGeomGetOffsetRotation)GetProcAddress(hDLL,"_odeGeomGetOffsetRotation@4");
typedef void(WINAPI *JVODE_DLL_dGeomGetOffsetQuaternion) (int geom);
JVODE_DLL_dGeomGetOffsetQuaternion dGeomGetOffsetQuaternion = (JVODE_DLL_dGeomGetOffsetQuaternion)GetProcAddress(hDLL,"_odeGeomGetOffsetQuaternion@4");
typedef void(WINAPI *JVODE_DLL_dGeomGetOffsetAxisAngle) (int geom);
JVODE_DLL_dGeomGetOffsetAxisAngle dGeomGetOffsetAxisAngle = (JVODE_DLL_dGeomGetOffsetAxisAngle)GetProcAddress(hDLL,"_odeGeomGetOffsetAxisAngle@4");
typedef int(WINAPI *JVODE_DLL_dCreateCapsule) (int space, float radius, float length);
JVODE_DLL_dCreateCapsule dCreateCapsule = (JVODE_DLL_dCreateCapsule)GetProcAddress(hDLL,"_odeCreateCapsule@12");
typedef void(WINAPI *JVODE_DLL_dGeomCapsuleSetParams) (int capsule, float radius, float length);
JVODE_DLL_dGeomCapsuleSetParams dGeomCapsuleSetParams = (JVODE_DLL_dGeomCapsuleSetParams)GetProcAddress(hDLL,"_odeGeomCapsuleSetParams@12");
typedef void(WINAPI *JVODE_DLL_dGeomCapsuleGetParams) (int capsule);
JVODE_DLL_dGeomCapsuleGetParams dGeomCapsuleGetParams = (JVODE_DLL_dGeomCapsuleGetParams)GetProcAddress(hDLL,"_odeGeomCapsuleGetParams@4");
typedef float(WINAPI *JVODE_DLL_dGeomCapsulePointDepth) (int capsule, float x, float y, float z);
JVODE_DLL_dGeomCapsulePointDepth dGeomCapsulePointDepth = (JVODE_DLL_dGeomCapsulePointDepth)GetProcAddress(hDLL,"_odeGeomCapsulePointDepth@16");
typedef int(WINAPI *JVODE_DLL_dCreateHeightfield) (int space, int heightdata, int bplaceable);
JVODE_DLL_dCreateHeightfield dCreateHeightfield = (JVODE_DLL_dCreateHeightfield)GetProcAddress(hDLL,"_odeCreateHeightfield@12");
typedef int(WINAPI *JVODE_DLL_dGeomHeightfieldDataCreate) ();
JVODE_DLL_dGeomHeightfieldDataCreate dGeomHeightfieldDataCreate = (JVODE_DLL_dGeomHeightfieldDataCreate)GetProcAddress(hDLL,"_odeGeomHeightfieldDataCreate@0");
typedef void(WINAPI *JVODE_DLL_dGeomHeightfieldDataDestroy) (int heightdata);
JVODE_DLL_dGeomHeightfieldDataDestroy dGeomHeightfieldDataDestroy = (JVODE_DLL_dGeomHeightfieldDataDestroy)GetProcAddress(hDLL,"_odeGeomHeightfieldDataDestroy@4");
typedef void(WINAPI *JVODE_DLL_dGeomHeightfieldDataBuildSingle) (int heightdata, int pheightdata, int bcopyheightdata, float width, float depth, int widthsamples, int depthsamples, float scale, float offset, float thickness, int bwrap);
JVODE_DLL_dGeomHeightfieldDataBuildSingle dGeomHeightfieldDataBuildSingle = (JVODE_DLL_dGeomHeightfieldDataBuildSingle)GetProcAddress(hDLL,"_odeGeomHeightfieldDataBuildSingle@44");
typedef void(WINAPI *JVODE_DLL_dGeomHeightfieldDataSetBounds) (int heightdata, float minheight, float maxheight);
JVODE_DLL_dGeomHeightfieldDataSetBounds dGeomHeightfieldDataSetBounds = (JVODE_DLL_dGeomHeightfieldDataSetBounds)GetProcAddress(hDLL,"_odeGeomHeightfieldDataSetBounds@12");
typedef void(WINAPI *JVODE_DLL_dGeomHeightfieldSetHeightfieldData) (int geom, int heightdata);
JVODE_DLL_dGeomHeightfieldSetHeightfieldData dGeomHeightfieldSetHeightfieldData = (JVODE_DLL_dGeomHeightfieldSetHeightfieldData)GetProcAddress(hDLL,"_odeGeomHeightfieldSetHeightfieldData@8");
typedef int(WINAPI *JVODE_DLL_dGeomHeightfieldGetHeightfieldData) (int geom);
JVODE_DLL_dGeomHeightfieldGetHeightfieldData dGeomHeightfieldGetHeightfieldData = (JVODE_DLL_dGeomHeightfieldGetHeightfieldData)GetProcAddress(hDLL,"_odeGeomHeightfieldGetHeightfieldData@4");
typedef int(WINAPI *JVODE_DLL_dCreateConvex) (int space, int planes, int planecount, int points, int pointcount, int polygons);
JVODE_DLL_dCreateConvex dCreateConvex = (JVODE_DLL_dCreateConvex)GetProcAddress(hDLL,"_odeCreateConvex@24");
typedef void(WINAPI *JVODE_DLL_dGeomSetConvex) (int geom, int planes, int planecount, int points, int pointcount, int polygons);
JVODE_DLL_dGeomSetConvex dGeomSetConvex = (JVODE_DLL_dGeomSetConvex)GetProcAddress(hDLL,"_odeGeomSetConvex@24");

// ### Joint Functions
typedef int(WINAPI *JVODE_DLL_dJointCreateBall) (int world, int group);
JVODE_DLL_dJointCreateBall dJointCreateBall = (JVODE_DLL_dJointCreateBall)GetProcAddress(hDLL,"_odeJointCreateBall@8");
typedef void(WINAPI *JVODE_DLL_dJointSetBallAnchor) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetBallAnchor dJointSetBallAnchor = (JVODE_DLL_dJointSetBallAnchor)GetProcAddress(hDLL,"_odeJointSetBallAnchor@16");
typedef void(WINAPI *JVODE_DLL_dJointSetBallAnchor2) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetBallAnchor2 dJointSetBallAnchor2 = (JVODE_DLL_dJointSetBallAnchor2)GetProcAddress(hDLL,"_odeJointSetBallAnchor2@16");
typedef void(WINAPI *JVODE_DLL_dJointSetBallParam) (int joint, int param, float value);
JVODE_DLL_dJointSetBallParam dJointSetBallParam = (JVODE_DLL_dJointSetBallParam)GetProcAddress(hDLL,"_odeJointSetBallParam@12");
typedef void(WINAPI *JVODE_DLL_dJointGetBallAnchor) (int joint);
JVODE_DLL_dJointGetBallAnchor dJointGetBallAnchor = (JVODE_DLL_dJointGetBallAnchor)GetProcAddress(hDLL,"_odeJointGetBallAnchor@4");
typedef void(WINAPI *JVODE_DLL_dJointGetBallAnchor2) (int joint);
JVODE_DLL_dJointGetBallAnchor2 dJointGetBallAnchor2 = (JVODE_DLL_dJointGetBallAnchor2)GetProcAddress(hDLL,"_odeJointGetBallAnchor2@4");
typedef float(WINAPI *JVODE_DLL_dJointGetBallParam) (int joint, int param);
JVODE_DLL_dJointGetBallParam dJointGetBallParam = (JVODE_DLL_dJointGetBallParam)GetProcAddress(hDLL,"_odeJointGetBallParam@8");
typedef int(WINAPI *JVODE_DLL_dJointCreateHinge) (int world, int group);
JVODE_DLL_dJointCreateHinge dJointCreateHinge = (JVODE_DLL_dJointCreateHinge)GetProcAddress(hDLL,"_odeJointCreateHinge@8");
typedef void(WINAPI *JVODE_DLL_dJointSetHingeAnchor) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetHingeAnchor dJointSetHingeAnchor = (JVODE_DLL_dJointSetHingeAnchor)GetProcAddress(hDLL,"_odeJointSetHingeAnchor@16");
typedef void(WINAPI *JVODE_DLL_dJointSetHingeAnchorDelta) (int joint, float x, float y, float z, float ax, float ay, float az);
JVODE_DLL_dJointSetHingeAnchorDelta dJointSetHingeAnchorDelta = (JVODE_DLL_dJointSetHingeAnchorDelta)GetProcAddress(hDLL,"_odeJointSetHingeAnchorDelta@28");
typedef void(WINAPI *JVODE_DLL_dJointSetHingeAxis) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetHingeAxis dJointSetHingeAxis = (JVODE_DLL_dJointSetHingeAxis)GetProcAddress(hDLL,"_odeJointSetHingeAxis@16");
typedef void(WINAPI *JVODE_DLL_dJointSetHingeAxisOffset) (int joint, float x, float y, float z, float angle);
JVODE_DLL_dJointSetHingeAxisOffset dJointSetHingeAxisOffset = (JVODE_DLL_dJointSetHingeAxisOffset)GetProcAddress(hDLL,"_odeJointSetHingeAxisOffset@20");
typedef void(WINAPI *JVODE_DLL_dJointSetHingeParam) (int joint, int param, float value);
JVODE_DLL_dJointSetHingeParam dJointSetHingeParam = (JVODE_DLL_dJointSetHingeParam)GetProcAddress(hDLL,"_odeJointSetHingeParam@12");
typedef void(WINAPI *JVODE_DLL_dJointAddHingeTorque) (int joint, float torque);
JVODE_DLL_dJointAddHingeTorque dJointAddHingeTorque = (JVODE_DLL_dJointAddHingeTorque)GetProcAddress(hDLL,"_odeJointAddHingeTorque@8");
typedef void(WINAPI *JVODE_DLL_dJointGetHingeAnchor) (int joint);
JVODE_DLL_dJointGetHingeAnchor dJointGetHingeAnchor = (JVODE_DLL_dJointGetHingeAnchor)GetProcAddress(hDLL,"_odeJointGetHingeAnchor@4");
typedef void(WINAPI *JVODE_DLL_dJointGetHingeAnchor2) (int joint);
JVODE_DLL_dJointGetHingeAnchor2 dJointGetHingeAnchor2 = (JVODE_DLL_dJointGetHingeAnchor2)GetProcAddress(hDLL,"_odeJointGetHingeAnchor2@4");
typedef void(WINAPI *JVODE_DLL_dJointGetHingeAxis) (int joint);
JVODE_DLL_dJointGetHingeAxis dJointGetHingeAxis = (JVODE_DLL_dJointGetHingeAxis)GetProcAddress(hDLL,"_odeJointGetHingeAxis@4");
typedef float(WINAPI *JVODE_DLL_dJointGetHingeAngle) (int joint);
JVODE_DLL_dJointGetHingeAngle dJointGetHingeAngle = (JVODE_DLL_dJointGetHingeAngle)GetProcAddress(hDLL,"_odeJointGetHingeAngle@4");
typedef float(WINAPI *JVODE_DLL_dJointGetHingeAngleRate) (int joint);
JVODE_DLL_dJointGetHingeAngleRate dJointGetHingeAngleRate = (JVODE_DLL_dJointGetHingeAngleRate)GetProcAddress(hDLL,"_odeJointGetHingeAngleRate@4");
typedef float(WINAPI *JVODE_DLL_dJointGetHingeParam) (int joint, int param);
JVODE_DLL_dJointGetHingeParam dJointGetHingeParam = (JVODE_DLL_dJointGetHingeParam)GetProcAddress(hDLL,"_odeJointGetHingeParam@8");
typedef int(WINAPI *JVODE_DLL_dJointCreateSlider) (int world, int group);
JVODE_DLL_dJointCreateSlider dJointCreateSlider = (JVODE_DLL_dJointCreateSlider)GetProcAddress(hDLL,"_odeJointCreateSlider@8");
typedef void(WINAPI *JVODE_DLL_dJointSetSliderAxis) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetSliderAxis dJointSetSliderAxis = (JVODE_DLL_dJointSetSliderAxis)GetProcAddress(hDLL,"_odeJointSetSliderAxis@16");
typedef void(WINAPI *JVODE_DLL_dJointSetSliderAxisDelta) (int joint, float x, float y, float z, float ax, float ay, float az);
JVODE_DLL_dJointSetSliderAxisDelta dJointSetSliderAxisDelta = (JVODE_DLL_dJointSetSliderAxisDelta)GetProcAddress(hDLL,"_odeJointSetSliderAxisDelta@28");
typedef void(WINAPI *JVODE_DLL_dJointSetSliderParam) (int joint, int param, float value);
JVODE_DLL_dJointSetSliderParam dJointSetSliderParam = (JVODE_DLL_dJointSetSliderParam)GetProcAddress(hDLL,"_odeJointSetSliderParam@12");
typedef void(WINAPI *JVODE_DLL_dJointAddSliderForce) (int joint, float force);
JVODE_DLL_dJointAddSliderForce dJointAddSliderForce = (JVODE_DLL_dJointAddSliderForce)GetProcAddress(hDLL,"_odeJointAddSliderForce@8");
typedef void(WINAPI *JVODE_DLL_dJointGetSliderAxis) (int joint);
JVODE_DLL_dJointGetSliderAxis dJointGetSliderAxis = (JVODE_DLL_dJointGetSliderAxis)GetProcAddress(hDLL,"_odeJointGetSliderAxis@4");
typedef float(WINAPI *JVODE_DLL_dJointGetSliderPosition) (int joint);
JVODE_DLL_dJointGetSliderPosition dJointGetSliderPosition = (JVODE_DLL_dJointGetSliderPosition)GetProcAddress(hDLL,"_odeJointGetSliderPosition@4");
typedef float(WINAPI *JVODE_DLL_dJointGetSliderPositionRate) (int joint);
JVODE_DLL_dJointGetSliderPositionRate dJointGetSliderPositionRate = (JVODE_DLL_dJointGetSliderPositionRate)GetProcAddress(hDLL,"_odeJointGetSliderPositionRate@4");
typedef float(WINAPI *JVODE_DLL_dJointGetSliderParam) (int joint, int param);
JVODE_DLL_dJointGetSliderParam dJointGetSliderParam = (JVODE_DLL_dJointGetSliderParam)GetProcAddress(hDLL,"_odeJointGetSliderParam@8");
typedef int(WINAPI *JVODE_DLL_dJointCreateUniversal) (int world, int group);
JVODE_DLL_dJointCreateUniversal dJointCreateUniversal = (JVODE_DLL_dJointCreateUniversal)GetProcAddress(hDLL,"_odeJointCreateUniversal@8");
typedef void(WINAPI *JVODE_DLL_dJointSetUniversalAnchor) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetUniversalAnchor dJointSetUniversalAnchor = (JVODE_DLL_dJointSetUniversalAnchor)GetProcAddress(hDLL,"_odeJointSetUniversalAnchor@16");
typedef void(WINAPI *JVODE_DLL_dJointSetUniversalAxis1) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetUniversalAxis1 dJointSetUniversalAxis1 = (JVODE_DLL_dJointSetUniversalAxis1)GetProcAddress(hDLL,"_odeJointSetUniversalAxis1@16");
typedef void(WINAPI *JVODE_DLL_dJointSetUniversalAxis2) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetUniversalAxis2 dJointSetUniversalAxis2 = (JVODE_DLL_dJointSetUniversalAxis2)GetProcAddress(hDLL,"_odeJointSetUniversalAxis2@16");
typedef void(WINAPI *JVODE_DLL_dJointSetUniversalParam) (int joint, int param, float value);
JVODE_DLL_dJointSetUniversalParam dJointSetUniversalParam = (JVODE_DLL_dJointSetUniversalParam)GetProcAddress(hDLL,"_odeJointSetUniversalParam@12");
typedef void(WINAPI *JVODE_DLL_dJointAddUniversalTorques) (int joint, float torque1, float torque2);
JVODE_DLL_dJointAddUniversalTorques dJointAddUniversalTorques = (JVODE_DLL_dJointAddUniversalTorques)GetProcAddress(hDLL,"_odeJointAddUniversalTorques@12");
typedef void(WINAPI *JVODE_DLL_dJointGetUniversalAnchor) (int joint);
JVODE_DLL_dJointGetUniversalAnchor dJointGetUniversalAnchor = (JVODE_DLL_dJointGetUniversalAnchor)GetProcAddress(hDLL,"_odeJointGetUniversalAnchor@4");
typedef void(WINAPI *JVODE_DLL_dJointGetUniversalAnchor2) (int joint);
JVODE_DLL_dJointGetUniversalAnchor2 dJointGetUniversalAnchor2 = (JVODE_DLL_dJointGetUniversalAnchor2)GetProcAddress(hDLL,"_odeJointGetUniversalAnchor2@4");
typedef void(WINAPI *JVODE_DLL_dJointGetUniversalAxis1) (int joint);
JVODE_DLL_dJointGetUniversalAxis1 dJointGetUniversalAxis1 = (JVODE_DLL_dJointGetUniversalAxis1)GetProcAddress(hDLL,"_odeJointGetUniversalAxis1@4");
typedef void(WINAPI *JVODE_DLL_dJointGetUniversalAxis2) (int joint);
JVODE_DLL_dJointGetUniversalAxis2 dJointGetUniversalAxis2 = (JVODE_DLL_dJointGetUniversalAxis2)GetProcAddress(hDLL,"_odeJointGetUniversalAxis2@4");
typedef void(WINAPI *JVODE_DLL_dJointGetUniversalAngles) (int joint);
JVODE_DLL_dJointGetUniversalAngles dJointGetUniversalAngles = (JVODE_DLL_dJointGetUniversalAngles)GetProcAddress(hDLL,"_odeJointGetUniversalAngles@4");
typedef float(WINAPI *JVODE_DLL_dJointGetUniversalAngle1) (int joint);
JVODE_DLL_dJointGetUniversalAngle1 dJointGetUniversalAngle1 = (JVODE_DLL_dJointGetUniversalAngle1)GetProcAddress(hDLL,"_odeJointGetUniversalAngle1@4");
typedef float(WINAPI *JVODE_DLL_dJointGetUniversalAngle2) (int joint);
JVODE_DLL_dJointGetUniversalAngle2 dJointGetUniversalAngle2 = (JVODE_DLL_dJointGetUniversalAngle2)GetProcAddress(hDLL,"_odeJointGetUniversalAngle2@4");
typedef float(WINAPI *JVODE_DLL_dJointGetUniversalAngle1Rate) (int joint);
JVODE_DLL_dJointGetUniversalAngle1Rate dJointGetUniversalAngle1Rate = (JVODE_DLL_dJointGetUniversalAngle1Rate)GetProcAddress(hDLL,"_odeJointGetUniversalAngle1Rate@4");
typedef float(WINAPI *JVODE_DLL_dJointGetUniversalAngle2Rate) (int joint);
JVODE_DLL_dJointGetUniversalAngle2Rate dJointGetUniversalAngle2Rate = (JVODE_DLL_dJointGetUniversalAngle2Rate)GetProcAddress(hDLL,"_odeJointGetUniversalAngle2Rate@4");
typedef float(WINAPI *JVODE_DLL_dJointGetUniversalParam) (int joint, int param);
JVODE_DLL_dJointGetUniversalParam dJointGetUniversalParam = (JVODE_DLL_dJointGetUniversalParam)GetProcAddress(hDLL,"_odeJointGetUniversalParam@8");
typedef int(WINAPI *JVODE_DLL_dJointCreateHinge2) (int world, int group);
JVODE_DLL_dJointCreateHinge2 dJointCreateHinge2 = (JVODE_DLL_dJointCreateHinge2)GetProcAddress(hDLL,"_odeJointCreateHinge2@8");
typedef void(WINAPI *JVODE_DLL_dJointSetHinge2Anchor) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetHinge2Anchor dJointSetHinge2Anchor = (JVODE_DLL_dJointSetHinge2Anchor)GetProcAddress(hDLL,"_odeJointSetHinge2Anchor@16");
typedef void(WINAPI *JVODE_DLL_dJointSetHinge2Axis1) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetHinge2Axis1 dJointSetHinge2Axis1 = (JVODE_DLL_dJointSetHinge2Axis1)GetProcAddress(hDLL,"_odeJointSetHinge2Axis1@16");
typedef void(WINAPI *JVODE_DLL_dJointSetHinge2Axis2) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetHinge2Axis2 dJointSetHinge2Axis2 = (JVODE_DLL_dJointSetHinge2Axis2)GetProcAddress(hDLL,"_odeJointSetHinge2Axis2@16");
typedef void(WINAPI *JVODE_DLL_dJointSetHinge2Param) (int joint, int param, float value);
JVODE_DLL_dJointSetHinge2Param dJointSetHinge2Param = (JVODE_DLL_dJointSetHinge2Param)GetProcAddress(hDLL,"_odeJointSetHinge2Param@12");
typedef void(WINAPI *JVODE_DLL_dJointAddHinge2Torques) (int joint, float torque1, float torque2);
JVODE_DLL_dJointAddHinge2Torques dJointAddHinge2Torques = (JVODE_DLL_dJointAddHinge2Torques)GetProcAddress(hDLL,"_odeJointAddHinge2Torques@12");
typedef void(WINAPI *JVODE_DLL_dJointGetHinge2Anchor) (int joint);
JVODE_DLL_dJointGetHinge2Anchor dJointGetHinge2Anchor = (JVODE_DLL_dJointGetHinge2Anchor)GetProcAddress(hDLL,"_odeJointGetHinge2Anchor@4");
typedef void(WINAPI *JVODE_DLL_dJointGetHinge2Anchor2) (int joint);
JVODE_DLL_dJointGetHinge2Anchor2 dJointGetHinge2Anchor2 = (JVODE_DLL_dJointGetHinge2Anchor2)GetProcAddress(hDLL,"_odeJointGetHinge2Anchor2@4");
typedef void(WINAPI *JVODE_DLL_dJointGetHinge2Axis1) (int joint);
JVODE_DLL_dJointGetHinge2Axis1 dJointGetHinge2Axis1 = (JVODE_DLL_dJointGetHinge2Axis1)GetProcAddress(hDLL,"_odeJointGetHinge2Axis1@4");
typedef void(WINAPI *JVODE_DLL_dJointGetHinge2Axis2) (int joint);
JVODE_DLL_dJointGetHinge2Axis2 dJointGetHinge2Axis2 = (JVODE_DLL_dJointGetHinge2Axis2)GetProcAddress(hDLL,"_odeJointGetHinge2Axis2@4");
typedef float(WINAPI *JVODE_DLL_dJointGetHinge2Angle1) (int joint);
JVODE_DLL_dJointGetHinge2Angle1 dJointGetHinge2Angle1 = (JVODE_DLL_dJointGetHinge2Angle1)GetProcAddress(hDLL,"_odeJointGetHinge2Angle1@4");
typedef float(WINAPI *JVODE_DLL_dJointGetHinge2Angle1Rate) (int joint);
JVODE_DLL_dJointGetHinge2Angle1Rate dJointGetHinge2Angle1Rate = (JVODE_DLL_dJointGetHinge2Angle1Rate)GetProcAddress(hDLL,"_odeJointGetHinge2Angle1Rate@4");
typedef float(WINAPI *JVODE_DLL_dJointGetHinge2Angle2Rate) (int joint);
JVODE_DLL_dJointGetHinge2Angle2Rate dJointGetHinge2Angle2Rate = (JVODE_DLL_dJointGetHinge2Angle2Rate)GetProcAddress(hDLL,"_odeJointGetHinge2Angle2Rate@4");
typedef float(WINAPI *JVODE_DLL_dJointGetHinge2Param) (int joint, int param);
JVODE_DLL_dJointGetHinge2Param dJointGetHinge2Param = (JVODE_DLL_dJointGetHinge2Param)GetProcAddress(hDLL,"_odeJointGetHinge2Param@8");
typedef int(WINAPI *JVODE_DLL_dJointCreateFixed) (int world, int group);
JVODE_DLL_dJointCreateFixed dJointCreateFixed = (JVODE_DLL_dJointCreateFixed)GetProcAddress(hDLL,"_odeJointCreateFixed@8");
typedef void(WINAPI *JVODE_DLL_dJointSetFixed) (int joint);
JVODE_DLL_dJointSetFixed dJointSetFixed = (JVODE_DLL_dJointSetFixed)GetProcAddress(hDLL,"_odeJointSetFixed@4");
typedef void(WINAPI *JVODE_DLL_dJointSetFixedParam) (int joint, int param, float value);
JVODE_DLL_dJointSetFixedParam dJointSetFixedParam = (JVODE_DLL_dJointSetFixedParam)GetProcAddress(hDLL,"_odeJointSetFixedParam@12");
typedef float(WINAPI *JVODE_DLL_dJointGetFixedParam) (int joint, int param);
JVODE_DLL_dJointGetFixedParam dJointGetFixedParam = (JVODE_DLL_dJointGetFixedParam)GetProcAddress(hDLL,"_odeJointGetFixedParam@8");
typedef int(WINAPI *JVODE_DLL_dJointCreateAMotor) (int world, int group);
JVODE_DLL_dJointCreateAMotor dJointCreateAMotor = (JVODE_DLL_dJointCreateAMotor)GetProcAddress(hDLL,"_odeJointCreateAMotor@8");
typedef void(WINAPI *JVODE_DLL_dJointSetAMotorMode) (int joint, int mode);
JVODE_DLL_dJointSetAMotorMode dJointSetAMotorMode = (JVODE_DLL_dJointSetAMotorMode)GetProcAddress(hDLL,"_odeJointSetAMotorMode@8");
typedef void(WINAPI *JVODE_DLL_dJointSetAMotorNumAxes) (int joint, int num);
JVODE_DLL_dJointSetAMotorNumAxes dJointSetAMotorNumAxes = (JVODE_DLL_dJointSetAMotorNumAxes)GetProcAddress(hDLL,"_odeJointSetAMotorNumAxes@8");
typedef void(WINAPI *JVODE_DLL_dJointSetAMotorAxis) (int joint, int num, int rel, float x, float y, float z);
JVODE_DLL_dJointSetAMotorAxis dJointSetAMotorAxis = (JVODE_DLL_dJointSetAMotorAxis)GetProcAddress(hDLL,"_odeJointSetAMotorAxis@24");
typedef void(WINAPI *JVODE_DLL_dJointSetAMotorAngle) (int joint, int num, float angle);
JVODE_DLL_dJointSetAMotorAngle dJointSetAMotorAngle = (JVODE_DLL_dJointSetAMotorAngle)GetProcAddress(hDLL,"_odeJointSetAMotorAngle@12");
typedef void(WINAPI *JVODE_DLL_dJointSetAMotorParam) (int joint, int param, float value);
JVODE_DLL_dJointSetAMotorParam dJointSetAMotorParam = (JVODE_DLL_dJointSetAMotorParam)GetProcAddress(hDLL,"_odeJointSetAMotorParam@12");
typedef void(WINAPI *JVODE_DLL_dJointAddAMotorTorques) (int joint, float torque0, float torque1, float torque2);
JVODE_DLL_dJointAddAMotorTorques dJointAddAMotorTorques = (JVODE_DLL_dJointAddAMotorTorques)GetProcAddress(hDLL,"_odeJointAddAMotorTorques@16");
typedef int(WINAPI *JVODE_DLL_dJointGetAMotorMode) (int joint);
JVODE_DLL_dJointGetAMotorMode dJointGetAMotorMode = (JVODE_DLL_dJointGetAMotorMode)GetProcAddress(hDLL,"_odeJointGetAMotorMode@4");
typedef int(WINAPI *JVODE_DLL_dJointGetAMotorNumAxes) (int joint);
JVODE_DLL_dJointGetAMotorNumAxes dJointGetAMotorNumAxes = (JVODE_DLL_dJointGetAMotorNumAxes)GetProcAddress(hDLL,"_odeJointGetAMotorNumAxes@4");
typedef void(WINAPI *JVODE_DLL_dJointGetAMotorAxis) (int joint, int num);
JVODE_DLL_dJointGetAMotorAxis dJointGetAMotorAxis = (JVODE_DLL_dJointGetAMotorAxis)GetProcAddress(hDLL,"_odeJointGetAMotorAxis@8");
typedef int(WINAPI *JVODE_DLL_dJointGetAMotorAxisRel) (int joint, int num);
JVODE_DLL_dJointGetAMotorAxisRel dJointGetAMotorAxisRel = (JVODE_DLL_dJointGetAMotorAxisRel)GetProcAddress(hDLL,"_odeJointGetAMotorAxisRel@8");
typedef float(WINAPI *JVODE_DLL_dJointGetAMotorAngle) (int joint, int num);
JVODE_DLL_dJointGetAMotorAngle dJointGetAMotorAngle = (JVODE_DLL_dJointGetAMotorAngle)GetProcAddress(hDLL,"_odeJointGetAMotorAngle@8");
typedef float(WINAPI *JVODE_DLL_dJointGetAMotorAngleRate) (int joint, int num);
JVODE_DLL_dJointGetAMotorAngleRate dJointGetAMotorAngleRate = (JVODE_DLL_dJointGetAMotorAngleRate)GetProcAddress(hDLL,"_odeJointGetAMotorAngleRate@8");
typedef float(WINAPI *JVODE_DLL_dJointGetAMotorParam) (int joint, int param);
JVODE_DLL_dJointGetAMotorParam dJointGetAMotorParam = (JVODE_DLL_dJointGetAMotorParam)GetProcAddress(hDLL,"_odeJointGetAMotorParam@8");
typedef void(WINAPI *JVODE_DLL_dJointDestroy) (int joint);
JVODE_DLL_dJointDestroy dJointDestroy = (JVODE_DLL_dJointDestroy)GetProcAddress(hDLL,"_odeJointDestroy@4");
typedef int(WINAPI *JVODE_DLL_dJointGroupCreate) (int maxsize);
JVODE_DLL_dJointGroupCreate dJointGroupCreate = (JVODE_DLL_dJointGroupCreate)GetProcAddress(hDLL,"_odeJointGroupCreate@4");
typedef void(WINAPI *JVODE_DLL_dJointGroupDestroy) (int group);
JVODE_DLL_dJointGroupDestroy dJointGroupDestroy = (JVODE_DLL_dJointGroupDestroy)GetProcAddress(hDLL,"_odeJointGroupDestroy@4");
typedef void(WINAPI *JVODE_DLL_dJointGroupEmpty) (int group);
JVODE_DLL_dJointGroupEmpty dJointGroupEmpty = (JVODE_DLL_dJointGroupEmpty)GetProcAddress(hDLL,"_odeJointGroupEmpty@4");
typedef void(WINAPI *JVODE_DLL_dJointAttach) (int joint, int body1, int body2);
JVODE_DLL_dJointAttach dJointAttach = (JVODE_DLL_dJointAttach)GetProcAddress(hDLL,"_odeJointAttach@12");
typedef void(WINAPI *JVODE_DLL_dJointSetData) (int joint, int data);
JVODE_DLL_dJointSetData dJointSetData = (JVODE_DLL_dJointSetData)GetProcAddress(hDLL,"_odeJointSetData@8");
typedef int(WINAPI *JVODE_DLL_dJointGetData) (int joint);
JVODE_DLL_dJointGetData dJointGetData = (JVODE_DLL_dJointGetData)GetProcAddress(hDLL,"_odeJointGetData@4");
typedef int(WINAPI *JVODE_DLL_dJointGetType) (int joint);
JVODE_DLL_dJointGetType dJointGetType = (JVODE_DLL_dJointGetType)GetProcAddress(hDLL,"_odeJointGetType@4");
typedef int(WINAPI *JVODE_DLL_dJointGetBody) (int joint, int index);
JVODE_DLL_dJointGetBody dJointGetBody = (JVODE_DLL_dJointGetBody)GetProcAddress(hDLL,"_odeJointGetBody@8");
typedef void(WINAPI *JVODE_DLL_dJointFeedbackEnable) (int joint);
JVODE_DLL_dJointFeedbackEnable dJointFeedbackEnable = (JVODE_DLL_dJointFeedbackEnable)GetProcAddress(hDLL,"_odeJointFeedbackEnable@4");
typedef void(WINAPI *JVODE_DLL_dJointFeedbackDisable) (int joint);
JVODE_DLL_dJointFeedbackDisable dJointFeedbackDisable = (JVODE_DLL_dJointFeedbackDisable)GetProcAddress(hDLL,"_odeJointFeedbackDisable@4");
typedef int(WINAPI *JVODE_DLL_dJointFeedbackIsEnabled) (int joint);
JVODE_DLL_dJointFeedbackIsEnabled dJointFeedbackIsEnabled = (JVODE_DLL_dJointFeedbackIsEnabled)GetProcAddress(hDLL,"_odeJointFeedbackIsEnabled@4");
typedef void(WINAPI *JVODE_DLL_dJointSetFeedback) (int joint, int feedback);
JVODE_DLL_dJointSetFeedback dJointSetFeedback = (JVODE_DLL_dJointSetFeedback)GetProcAddress(hDLL,"_odeJointSetFeedback@8");
typedef void(WINAPI *JVODE_DLL_dJointGetFeedbackForce1) (int joint);
JVODE_DLL_dJointGetFeedbackForce1 dJointGetFeedbackForce1 = (JVODE_DLL_dJointGetFeedbackForce1)GetProcAddress(hDLL,"_odeJointGetFeedbackForce1@4");
typedef void(WINAPI *JVODE_DLL_dJointGetFeedbackTorque1) (int joint);
JVODE_DLL_dJointGetFeedbackTorque1 dJointGetFeedbackTorque1 = (JVODE_DLL_dJointGetFeedbackTorque1)GetProcAddress(hDLL,"_odeJointGetFeedbackTorque1@4");
typedef void(WINAPI *JVODE_DLL_dJointGetFeedbackForce2) (int joint);
JVODE_DLL_dJointGetFeedbackForce2 dJointGetFeedbackForce2 = (JVODE_DLL_dJointGetFeedbackForce2)GetProcAddress(hDLL,"_odeJointGetFeedbackForce2@4");
typedef void(WINAPI *JVODE_DLL_dJointGetFeedbackTorque2) (int joint);
JVODE_DLL_dJointGetFeedbackTorque2 dJointGetFeedbackTorque2 = (JVODE_DLL_dJointGetFeedbackTorque2)GetProcAddress(hDLL,"_odeJointGetFeedbackTorque2@4");
typedef int(WINAPI *JVODE_DLL_dAreConnected) (int body1, int body2);
JVODE_DLL_dAreConnected dAreConnected = (JVODE_DLL_dAreConnected)GetProcAddress(hDLL,"_odeAreConnected@8");
typedef int(WINAPI *JVODE_DLL_dAreConnectedExcluding) (int body1, int body2, int jointtype);
JVODE_DLL_dAreConnectedExcluding dAreConnectedExcluding = (JVODE_DLL_dAreConnectedExcluding)GetProcAddress(hDLL,"_odeAreConnectedExcluding@12");
typedef int(WINAPI *JVODE_DLL_dConnectingJoint) (int body1, int body2);
JVODE_DLL_dConnectingJoint dConnectingJoint = (JVODE_DLL_dConnectingJoint)GetProcAddress(hDLL,"_odeConnectingJoint@8");
typedef int(WINAPI *JVODE_DLL_dJointCreateLMotor) (int world, int group);
JVODE_DLL_dJointCreateLMotor dJointCreateLMotor = (JVODE_DLL_dJointCreateLMotor)GetProcAddress(hDLL,"_odeJointCreateLMotor@8");
typedef void(WINAPI *JVODE_DLL_dJointSetLMotorNumAxes) (int joint, int num);
JVODE_DLL_dJointSetLMotorNumAxes dJointSetLMotorNumAxes = (JVODE_DLL_dJointSetLMotorNumAxes)GetProcAddress(hDLL,"_odeJointSetLMotorNumAxes@8");
typedef void(WINAPI *JVODE_DLL_dJointSetLMotorAxis) (int joint, int anum, int rel, float x, float y, float z);
JVODE_DLL_dJointSetLMotorAxis dJointSetLMotorAxis = (JVODE_DLL_dJointSetLMotorAxis)GetProcAddress(hDLL,"_odeJointSetLMotorAxis@24");
typedef void(WINAPI *JVODE_DLL_dJointSetLMotorParam) (int joint, int parameter, float value);
JVODE_DLL_dJointSetLMotorParam dJointSetLMotorParam = (JVODE_DLL_dJointSetLMotorParam)GetProcAddress(hDLL,"_odeJointSetLMotorParam@12");
typedef int(WINAPI *JVODE_DLL_dJointGetLMotorNumAxes) (int joint);
JVODE_DLL_dJointGetLMotorNumAxes dJointGetLMotorNumAxes = (JVODE_DLL_dJointGetLMotorNumAxes)GetProcAddress(hDLL,"_odeJointGetLMotorNumAxes@4");
typedef void(WINAPI *JVODE_DLL_dJointGetLMotorAxis) (int joint, int anum);
JVODE_DLL_dJointGetLMotorAxis dJointGetLMotorAxis = (JVODE_DLL_dJointGetLMotorAxis)GetProcAddress(hDLL,"_odeJointGetLMotorAxis@8");
typedef float(WINAPI *JVODE_DLL_dJointGetLMotorParam) (int joint, int parameter);
JVODE_DLL_dJointGetLMotorParam dJointGetLMotorParam = (JVODE_DLL_dJointGetLMotorParam)GetProcAddress(hDLL,"_odeJointGetLMotorParam@8");
typedef int(WINAPI *JVODE_DLL_dJointCreatePlane2D) (int world, int group);
JVODE_DLL_dJointCreatePlane2D dJointCreatePlane2D = (JVODE_DLL_dJointCreatePlane2D)GetProcAddress(hDLL,"_odeJointCreatePlane2D@8");
typedef void(WINAPI *JVODE_DLL_dJointSetPlane2DXParam) (int joint, int parameter, float value);
JVODE_DLL_dJointSetPlane2DXParam dJointSetPlane2DXParam = (JVODE_DLL_dJointSetPlane2DXParam)GetProcAddress(hDLL,"_odeJointSetPlane2DXParam@12");
typedef void(WINAPI *JVODE_DLL_dJointSetPlane2DYParam) (int joint, int parameter, float value);
JVODE_DLL_dJointSetPlane2DYParam dJointSetPlane2DYParam = (JVODE_DLL_dJointSetPlane2DYParam)GetProcAddress(hDLL,"_odeJointSetPlane2DYParam@12");
typedef void(WINAPI *JVODE_DLL_dJointSetPlane2DAngleParam) (int joint, int parameter, float value);
JVODE_DLL_dJointSetPlane2DAngleParam dJointSetPlane2DAngleParam = (JVODE_DLL_dJointSetPlane2DAngleParam)GetProcAddress(hDLL,"_odeJointSetPlane2DAngleParam@12");
typedef int(WINAPI *JVODE_DLL_dJointCreatePR) (int world, int group);
JVODE_DLL_dJointCreatePR dJointCreatePR = (JVODE_DLL_dJointCreatePR)GetProcAddress(hDLL,"_odeJointCreatePR@8");
typedef void(WINAPI *JVODE_DLL_dJointSetPRAnchor) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetPRAnchor dJointSetPRAnchor = (JVODE_DLL_dJointSetPRAnchor)GetProcAddress(hDLL,"_odeJointSetPRAnchor@16");
typedef void(WINAPI *JVODE_DLL_dJointSetPRAxis1) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetPRAxis1 dJointSetPRAxis1 = (JVODE_DLL_dJointSetPRAxis1)GetProcAddress(hDLL,"_odeJointSetPRAxis1@16");
typedef void(WINAPI *JVODE_DLL_dJointSetPRAxis2) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetPRAxis2 dJointSetPRAxis2 = (JVODE_DLL_dJointSetPRAxis2)GetProcAddress(hDLL,"_odeJointSetPRAxis2@16");
typedef void(WINAPI *JVODE_DLL_dJointSetPRParam) (int joint, int parameter, float value);
JVODE_DLL_dJointSetPRParam dJointSetPRParam = (JVODE_DLL_dJointSetPRParam)GetProcAddress(hDLL,"_odeJointSetPRParam@12");
typedef void(WINAPI *JVODE_DLL_dJointAddPRTorque) (int joint, float torque);
JVODE_DLL_dJointAddPRTorque dJointAddPRTorque = (JVODE_DLL_dJointAddPRTorque)GetProcAddress(hDLL,"_odeJointAddPRTorque@8");
typedef void(WINAPI *JVODE_DLL_dJointGetPRAnchor) (int joint);
JVODE_DLL_dJointGetPRAnchor dJointGetPRAnchor = (JVODE_DLL_dJointGetPRAnchor)GetProcAddress(hDLL,"_odeJointGetPRAnchor@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPRPosition) (int joint);
JVODE_DLL_dJointGetPRPosition dJointGetPRPosition = (JVODE_DLL_dJointGetPRPosition)GetProcAddress(hDLL,"_odeJointGetPRPosition@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPRPositionRate) (int joint);
JVODE_DLL_dJointGetPRPositionRate dJointGetPRPositionRate = (JVODE_DLL_dJointGetPRPositionRate)GetProcAddress(hDLL,"_odeJointGetPRPositionRate@4");
typedef void(WINAPI *JVODE_DLL_dJointGetPRAxis1) (int joint);
JVODE_DLL_dJointGetPRAxis1 dJointGetPRAxis1 = (JVODE_DLL_dJointGetPRAxis1)GetProcAddress(hDLL,"_odeJointGetPRAxis1@4");
typedef void(WINAPI *JVODE_DLL_dJointGetPRAxis2) (int joint);
JVODE_DLL_dJointGetPRAxis2 dJointGetPRAxis2 = (JVODE_DLL_dJointGetPRAxis2)GetProcAddress(hDLL,"_odeJointGetPRAxis2@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPRParam) (int joint, int parameter);
JVODE_DLL_dJointGetPRParam dJointGetPRParam = (JVODE_DLL_dJointGetPRParam)GetProcAddress(hDLL,"_odeJointGetPRParam@8");
typedef int(WINAPI *JVODE_DLL_dJointGetNumBodies) (int joint);
JVODE_DLL_dJointGetNumBodies dJointGetNumBodies = (JVODE_DLL_dJointGetNumBodies)GetProcAddress(hDLL,"_odeJointGetNumBodies@4");
typedef int(WINAPI *JVODE_DLL_dJointCreatePU) (int world, int group);
JVODE_DLL_dJointCreatePU dJointCreatePU = (JVODE_DLL_dJointCreatePU)GetProcAddress(hDLL,"_odeJointCreatePU@8");
typedef void(WINAPI *JVODE_DLL_dJointSetPUAnchor) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetPUAnchor dJointSetPUAnchor = (JVODE_DLL_dJointSetPUAnchor)GetProcAddress(hDLL,"_odeJointSetPUAnchor@16");
typedef void(WINAPI *JVODE_DLL_dJointSetPUAnchorDelta) (int joint, float x, float y, float z, float dx, float dy, float dz);
JVODE_DLL_dJointSetPUAnchorDelta dJointSetPUAnchorDelta = (JVODE_DLL_dJointSetPUAnchorDelta)GetProcAddress(hDLL,"_odeJointSetPUAnchorDelta@28");
typedef void(WINAPI *JVODE_DLL_dJointSetPUAxis1) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetPUAxis1 dJointSetPUAxis1 = (JVODE_DLL_dJointSetPUAxis1)GetProcAddress(hDLL,"_odeJointSetPUAxis1@16");
typedef void(WINAPI *JVODE_DLL_dJointSetPUAxis2) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetPUAxis2 dJointSetPUAxis2 = (JVODE_DLL_dJointSetPUAxis2)GetProcAddress(hDLL,"_odeJointSetPUAxis2@16");
typedef void(WINAPI *JVODE_DLL_dJointSetPUAxis3) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetPUAxis3 dJointSetPUAxis3 = (JVODE_DLL_dJointSetPUAxis3)GetProcAddress(hDLL,"_odeJointSetPUAxis3@16");
typedef void(WINAPI *JVODE_DLL_dJointSetPUAxisP) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetPUAxisP dJointSetPUAxisP = (JVODE_DLL_dJointSetPUAxisP)GetProcAddress(hDLL,"_odeJointSetPUAxisP@16");
typedef void(WINAPI *JVODE_DLL_dJointSetPUParam) (int joint, int parameter, float value);
JVODE_DLL_dJointSetPUParam dJointSetPUParam = (JVODE_DLL_dJointSetPUParam)GetProcAddress(hDLL,"_odeJointSetPUParam@12");
typedef float(WINAPI *JVODE_DLL_dJointGetPUPosition) (int joint);
JVODE_DLL_dJointGetPUPosition dJointGetPUPosition = (JVODE_DLL_dJointGetPUPosition)GetProcAddress(hDLL,"_odeJointGetPUPosition@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPUPositionRate) (int joint);
JVODE_DLL_dJointGetPUPositionRate dJointGetPUPositionRate = (JVODE_DLL_dJointGetPUPositionRate)GetProcAddress(hDLL,"_odeJointGetPUPositionRate@4");
typedef void(WINAPI *JVODE_DLL_dJointGetPUAnchor) (int joint);
JVODE_DLL_dJointGetPUAnchor dJointGetPUAnchor = (JVODE_DLL_dJointGetPUAnchor)GetProcAddress(hDLL,"_odeJointGetPUAnchor@4");
typedef void(WINAPI *JVODE_DLL_dJointGetPUAxis1) (int joint);
JVODE_DLL_dJointGetPUAxis1 dJointGetPUAxis1 = (JVODE_DLL_dJointGetPUAxis1)GetProcAddress(hDLL,"_odeJointGetPUAxis1@4");
typedef void(WINAPI *JVODE_DLL_dJointGetPUAxis2) (int joint);
JVODE_DLL_dJointGetPUAxis2 dJointGetPUAxis2 = (JVODE_DLL_dJointGetPUAxis2)GetProcAddress(hDLL,"_odeJointGetPUAxis2@4");
typedef void(WINAPI *JVODE_DLL_dJointGetPUAxis3) (int joint);
JVODE_DLL_dJointGetPUAxis3 dJointGetPUAxis3 = (JVODE_DLL_dJointGetPUAxis3)GetProcAddress(hDLL,"_odeJointGetPUAxis3@4");
typedef void(WINAPI *JVODE_DLL_dJointGetPUAxisP) (int joint);
JVODE_DLL_dJointGetPUAxisP dJointGetPUAxisP = (JVODE_DLL_dJointGetPUAxisP)GetProcAddress(hDLL,"_odeJointGetPUAxisP@4");
typedef void(WINAPI *JVODE_DLL_dJointGetPUAngles) (int joint);
JVODE_DLL_dJointGetPUAngles dJointGetPUAngles = (JVODE_DLL_dJointGetPUAngles)GetProcAddress(hDLL,"_odeJointGetPUAngles@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPUAngle1) (int joint);
JVODE_DLL_dJointGetPUAngle1 dJointGetPUAngle1 = (JVODE_DLL_dJointGetPUAngle1)GetProcAddress(hDLL,"_odeJointGetPUAngle1@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPUAngle2) (int joint);
JVODE_DLL_dJointGetPUAngle2 dJointGetPUAngle2 = (JVODE_DLL_dJointGetPUAngle2)GetProcAddress(hDLL,"_odeJointGetPUAngle2@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPUAngle1Rate) (int joint);
JVODE_DLL_dJointGetPUAngle1Rate dJointGetPUAngle1Rate = (JVODE_DLL_dJointGetPUAngle1Rate)GetProcAddress(hDLL,"_odeJointGetPUAngle1Rate@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPUAngle2Rate) (int joint);
JVODE_DLL_dJointGetPUAngle2Rate dJointGetPUAngle2Rate = (JVODE_DLL_dJointGetPUAngle2Rate)GetProcAddress(hDLL,"_odeJointGetPUAngle2Rate@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPUParam) (int joint, int parameter);
JVODE_DLL_dJointGetPUParam dJointGetPUParam = (JVODE_DLL_dJointGetPUParam)GetProcAddress(hDLL,"_odeJointGetPUParam@8");
typedef int(WINAPI *JVODE_DLL_dJointCreatePiston) (int world, int group);
JVODE_DLL_dJointCreatePiston dJointCreatePiston = (JVODE_DLL_dJointCreatePiston)GetProcAddress(hDLL,"_odeJointCreatePiston@8");
typedef void(WINAPI *JVODE_DLL_dJointSetPistonAnchor) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetPistonAnchor dJointSetPistonAnchor = (JVODE_DLL_dJointSetPistonAnchor)GetProcAddress(hDLL,"_odeJointSetPistonAnchor@16");
typedef void(WINAPI *JVODE_DLL_dJointSetPistonAnchorOffset) (int joint, float x, float y, float z, float dx, float dy, float dz);
JVODE_DLL_dJointSetPistonAnchorOffset dJointSetPistonAnchorOffset = (JVODE_DLL_dJointSetPistonAnchorOffset)GetProcAddress(hDLL,"_odeJointSetPistonAnchorOffset@28");
typedef void(WINAPI *JVODE_DLL_dJointSetPistonAxis) (int joint, float x, float y, float z);
JVODE_DLL_dJointSetPistonAxis dJointSetPistonAxis = (JVODE_DLL_dJointSetPistonAxis)GetProcAddress(hDLL,"_odeJointSetPistonAxis@16");
typedef void(WINAPI *JVODE_DLL_dJointSetPistonParam) (int joint, int parameter, float value);
JVODE_DLL_dJointSetPistonParam dJointSetPistonParam = (JVODE_DLL_dJointSetPistonParam)GetProcAddress(hDLL,"_odeJointSetPistonParam@12");
typedef void(WINAPI *JVODE_DLL_dJointGetPistonAnchor) (int joint);
JVODE_DLL_dJointGetPistonAnchor dJointGetPistonAnchor = (JVODE_DLL_dJointGetPistonAnchor)GetProcAddress(hDLL,"_odeJointGetPistonAnchor@4");
typedef void(WINAPI *JVODE_DLL_dJointGetPistonAnchor2) (int joint);
JVODE_DLL_dJointGetPistonAnchor2 dJointGetPistonAnchor2 = (JVODE_DLL_dJointGetPistonAnchor2)GetProcAddress(hDLL,"_odeJointGetPistonAnchor2@4");
typedef void(WINAPI *JVODE_DLL_dJointGetPistonAxis) (int joint);
JVODE_DLL_dJointGetPistonAxis dJointGetPistonAxis = (JVODE_DLL_dJointGetPistonAxis)GetProcAddress(hDLL,"_odeJointGetPistonAxis@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPistonPosition) (int joint);
JVODE_DLL_dJointGetPistonPosition dJointGetPistonPosition = (JVODE_DLL_dJointGetPistonPosition)GetProcAddress(hDLL,"_odeJointGetPistonPosition@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPistonPositionRate) (int joint);
JVODE_DLL_dJointGetPistonPositionRate dJointGetPistonPositionRate = (JVODE_DLL_dJointGetPistonPositionRate)GetProcAddress(hDLL,"_odeJointGetPistonPositionRate@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPistonAngle) (int joint);
JVODE_DLL_dJointGetPistonAngle dJointGetPistonAngle = (JVODE_DLL_dJointGetPistonAngle)GetProcAddress(hDLL,"_odeJointGetPistonAngle@4");
typedef float(WINAPI *JVODE_DLL_dJointGetPistonAngleRate) (int joint);
JVODE_DLL_dJointGetPistonAngleRate dJointGetPistonAngleRate = (JVODE_DLL_dJointGetPistonAngleRate)GetProcAddress(hDLL,"_odeJointGetPistonAngleRate@4");
typedef void(WINAPI *JVODE_DLL_dJointAddPistonForce) (int joint, float force);
JVODE_DLL_dJointAddPistonForce dJointAddPistonForce = (JVODE_DLL_dJointAddPistonForce)GetProcAddress(hDLL,"_odeJointAddPistonForce@8");
typedef float(WINAPI *JVODE_DLL_dJointGetPistonParam) (int joint, int parameter);
JVODE_DLL_dJointGetPistonParam dJointGetPistonParam = (JVODE_DLL_dJointGetPistonParam)GetProcAddress(hDLL,"_odeJointGetPistonParam@8");

// ### Mass Functions
typedef int(WINAPI *JVODE_DLL_dMassCreate) ();
JVODE_DLL_dMassCreate dMassCreate = (JVODE_DLL_dMassCreate)GetProcAddress(hDLL,"_odeMassCreate@0");
typedef void(WINAPI *JVODE_DLL_dMassDestroy) (int mass);
JVODE_DLL_dMassDestroy dMassDestroy = (JVODE_DLL_dMassDestroy)GetProcAddress(hDLL,"_odeMassDestroy@4");
typedef void(WINAPI *JVODE_DLL_dMassSetZero) (int mass);
JVODE_DLL_dMassSetZero dMassSetZero = (JVODE_DLL_dMassSetZero)GetProcAddress(hDLL,"_odeMassSetZero@4");
typedef void(WINAPI *JVODE_DLL_dMassSetParameters) (int mass, float themass, float cgx, float cgy, float cgz, float I11, float I22, float I33, float I12, float I13, float I23);
JVODE_DLL_dMassSetParameters dMassSetParameters = (JVODE_DLL_dMassSetParameters)GetProcAddress(hDLL,"_odeMassSetParameters@44");
typedef void(WINAPI *JVODE_DLL_dMassSetSphere) (int mass, float density, float radius);
JVODE_DLL_dMassSetSphere dMassSetSphere = (JVODE_DLL_dMassSetSphere)GetProcAddress(hDLL,"_odeMassSetSphere@12");
typedef void(WINAPI *JVODE_DLL_dMassSetSphereTotal) (int mass, float totalmass, float radius);
JVODE_DLL_dMassSetSphereTotal dMassSetSphereTotal = (JVODE_DLL_dMassSetSphereTotal)GetProcAddress(hDLL,"_odeMassSetSphereTotal@12");
typedef void(WINAPI *JVODE_DLL_dMassSetCappedCylinder) (int mass, float density, int direction, float radius, float length);
JVODE_DLL_dMassSetCappedCylinder dMassSetCappedCylinder = (JVODE_DLL_dMassSetCappedCylinder)GetProcAddress(hDLL,"_odeMassSetCappedCylinder@20");
typedef void(WINAPI *JVODE_DLL_dMassSetCappedCylinderTotal) (int mass, float totalmass, int direction, float radius, float length);
JVODE_DLL_dMassSetCappedCylinderTotal dMassSetCappedCylinderTotal = (JVODE_DLL_dMassSetCappedCylinderTotal)GetProcAddress(hDLL,"_odeMassSetCappedCylinderTotal@20");
typedef void(WINAPI *JVODE_DLL_dMassSetCylinder) (int mass, float density, int direction, float radius, float length);
JVODE_DLL_dMassSetCylinder dMassSetCylinder = (JVODE_DLL_dMassSetCylinder)GetProcAddress(hDLL,"_odeMassSetCylinder@20");
typedef void(WINAPI *JVODE_DLL_dMassSetCylinderTotal) (int mass, float totalmass, int direction, float radius, float length);
JVODE_DLL_dMassSetCylinderTotal dMassSetCylinderTotal = (JVODE_DLL_dMassSetCylinderTotal)GetProcAddress(hDLL,"_odeMassSetCylinderTotal@20");
typedef void(WINAPI *JVODE_DLL_dMassSetBox) (int mass, float density, float lx, float ly, float lz);
JVODE_DLL_dMassSetBox dMassSetBox = (JVODE_DLL_dMassSetBox)GetProcAddress(hDLL,"_odeMassSetBox@20");
typedef void(WINAPI *JVODE_DLL_dMassSetBoxTotal) (int mass, float totalmass, float lx, float ly, float lz);
JVODE_DLL_dMassSetBoxTotal dMassSetBoxTotal = (JVODE_DLL_dMassSetBoxTotal)GetProcAddress(hDLL,"_odeMassSetBoxTotal@20");
typedef void(WINAPI *JVODE_DLL_dMassSetTriMesh) (int mass, float density, int geom);
JVODE_DLL_dMassSetTriMesh dMassSetTriMesh = (JVODE_DLL_dMassSetTriMesh)GetProcAddress(hDLL,"_odeMassSetTriMesh@12");
typedef void(WINAPI *JVODE_DLL_dMassSetTriMeshTotal) (int mass, float totalmass, int geom);
JVODE_DLL_dMassSetTriMeshTotal dMassSetTriMeshTotal = (JVODE_DLL_dMassSetTriMeshTotal)GetProcAddress(hDLL,"_odeMassSetTriMeshTotal@12");
typedef void(WINAPI *JVODE_DLL_dMassAdjust) (int mass, float newmass);
JVODE_DLL_dMassAdjust dMassAdjust = (JVODE_DLL_dMassAdjust)GetProcAddress(hDLL,"_odeMassAdjust@8");
typedef void(WINAPI *JVODE_DLL_dMassTranslate) (int mass, float x, float y, float z);
JVODE_DLL_dMassTranslate dMassTranslate = (JVODE_DLL_dMassTranslate)GetProcAddress(hDLL,"_odeMassTranslate@16");
typedef void(WINAPI *JVODE_DLL_dMassRotate) (int mass, float pitch, float yaw, float roll);
JVODE_DLL_dMassRotate dMassRotate = (JVODE_DLL_dMassRotate)GetProcAddress(hDLL,"_odeMassRotate@16");
typedef void(WINAPI *JVODE_DLL_dMassRotateQuaternion) (int mass, float qw, float qx, float qy, float qz);
JVODE_DLL_dMassRotateQuaternion dMassRotateQuaternion = (JVODE_DLL_dMassRotateQuaternion)GetProcAddress(hDLL,"_odeMassRotateQuaternion@20");
typedef void(WINAPI *JVODE_DLL_dMassRotateAxisAngle) (int mass, float angle, float rx, float ry, float rz);
JVODE_DLL_dMassRotateAxisAngle dMassRotateAxisAngle = (JVODE_DLL_dMassRotateAxisAngle)GetProcAddress(hDLL,"_odeMassRotateAxisAngle@20");
typedef void(WINAPI *JVODE_DLL_dMassAdd) (int massa, int massb);
JVODE_DLL_dMassAdd dMassAdd = (JVODE_DLL_dMassAdd)GetProcAddress(hDLL,"_odeMassAdd@8");
typedef void(WINAPI *JVODE_DLL_dMassCenter) (int mass);
JVODE_DLL_dMassCenter dMassCenter = (JVODE_DLL_dMassCenter)GetProcAddress(hDLL,"_odeMassCenter@4");
typedef void(WINAPI *JVODE_DLL_dMassSetCapsule) (int mass, float density, int direction, float radius, float length);
JVODE_DLL_dMassSetCapsule dMassSetCapsule = (JVODE_DLL_dMassSetCapsule)GetProcAddress(hDLL,"_odeMassSetCapsule@20");
typedef void(WINAPI *JVODE_DLL_dMassSetCapsuleTotal) (int mass, float totalmass, int direction, float radius, float length);
JVODE_DLL_dMassSetCapsuleTotal dMassSetCapsuleTotal = (JVODE_DLL_dMassSetCapsuleTotal)GetProcAddress(hDLL,"_odeMassSetCapsuleTotal@20");

// ### Collision Detection Functions
typedef void(WINAPI *JVODE_DLL_dSpaceCollide) (int space, int world, int group);
JVODE_DLL_dSpaceCollide dSpaceCollide = (JVODE_DLL_dSpaceCollide)GetProcAddress(hDLL,"_odeSpaceCollide@12");
typedef void(WINAPI *JVODE_DLL_dSpaceCollide2) (int geom1, int geom2, int world, int group);
JVODE_DLL_dSpaceCollide2 dSpaceCollide2 = (JVODE_DLL_dSpaceCollide2)GetProcAddress(hDLL,"_odeSpaceCollide2@16");

// ### Internal Collision Functions (Unique JV-ODE Functions)
typedef void(WINAPI *JVODE_DLL_dSetInternalSpaceCollideMode) (int mode);
JVODE_DLL_dSetInternalSpaceCollideMode dSetInternalSpaceCollideMode = (JVODE_DLL_dSetInternalSpaceCollideMode)GetProcAddress(hDLL,"_odeSetInternalSpaceCollideMode@4");
typedef int(WINAPI *JVODE_DLL_dGetInternalSpaceCollideMode) ();
JVODE_DLL_dGetInternalSpaceCollideMode dGetInternalSpaceCollideMode = (JVODE_DLL_dGetInternalSpaceCollideMode)GetProcAddress(hDLL,"_odeGetInternalSpaceCollideMode@0");
typedef void(WINAPI *JVODE_DLL_dSetInternalContactSurfaceMode) (int mode);
JVODE_DLL_dSetInternalContactSurfaceMode dSetInternalContactSurfaceMode = (JVODE_DLL_dSetInternalContactSurfaceMode)GetProcAddress(hDLL,"_odeSetInternalContactSurfaceMode@4");
typedef int(WINAPI *JVODE_DLL_dGetInternalContactSurfaceMode) ();
JVODE_DLL_dGetInternalContactSurfaceMode dGetInternalContactSurfaceMode = (JVODE_DLL_dGetInternalContactSurfaceMode)GetProcAddress(hDLL,"_odeGetInternalContactSurfaceMode@0");

// ### Contact Functions (Unique JV-ODE Functions)
typedef void(WINAPI *JVODE_DLL_dContactSetMaxContacts) (int max);
JVODE_DLL_dContactSetMaxContacts dContactSetMaxContacts = (JVODE_DLL_dContactSetMaxContacts)GetProcAddress(hDLL,"_odeContactSetMaxContacts@4");
typedef int(WINAPI *JVODE_DLL_dContactGetMaxContacts) ();
JVODE_DLL_dContactGetMaxContacts dContactGetMaxContacts = (JVODE_DLL_dContactGetMaxContacts)GetProcAddress(hDLL,"_odeContactGetMaxContacts@0");
typedef void(WINAPI *JVODE_DLL_dContactSetMode) (int mode);
JVODE_DLL_dContactSetMode dContactSetMode = (JVODE_DLL_dContactSetMode)GetProcAddress(hDLL,"_odeContactSetMode@4");
typedef int(WINAPI *JVODE_DLL_dContactGetMode) ();
JVODE_DLL_dContactGetMode dContactGetMode = (JVODE_DLL_dContactGetMode)GetProcAddress(hDLL,"_odeContactGetMode@0");
typedef void(WINAPI *JVODE_DLL_dContactSetMu) (float mu);
JVODE_DLL_dContactSetMu dContactSetMu = (JVODE_DLL_dContactSetMu)GetProcAddress(hDLL,"_odeContactSetMu@4");
typedef float(WINAPI *JVODE_DLL_dContactGetMu) ();
JVODE_DLL_dContactGetMu dContactGetMu = (JVODE_DLL_dContactGetMu)GetProcAddress(hDLL,"_odeContactGetMu@0");
typedef void(WINAPI *JVODE_DLL_dContactSetMu2) (float mu);
JVODE_DLL_dContactSetMu2 dContactSetMu2 = (JVODE_DLL_dContactSetMu2)GetProcAddress(hDLL,"_odeContactSetMu2@4");
typedef float(WINAPI *JVODE_DLL_dContactGetMu2) ();
JVODE_DLL_dContactGetMu2 dContactGetMu2 = (JVODE_DLL_dContactGetMu2)GetProcAddress(hDLL,"_odeContactGetMu2@0");
typedef void(WINAPI *JVODE_DLL_dContactSetFDir1) (float fdir1x, float fdir1y, float fdir1z);
JVODE_DLL_dContactSetFDir1 dContactSetFDir1 = (JVODE_DLL_dContactSetFDir1)GetProcAddress(hDLL,"_odeContactSetFDir1@12");
typedef void(WINAPI *JVODE_DLL_dContactGetFDir1) ();
JVODE_DLL_dContactGetFDir1 dContactGetFDir1 = (JVODE_DLL_dContactGetFDir1)GetProcAddress(hDLL,"_odeContactGetFDir1@0");
typedef void(WINAPI *JVODE_DLL_dContactSetBounce) (float bounce);
JVODE_DLL_dContactSetBounce dContactSetBounce = (JVODE_DLL_dContactSetBounce)GetProcAddress(hDLL,"_odeContactSetBounce@4");
typedef float(WINAPI *JVODE_DLL_dContactGetBounce) ();
JVODE_DLL_dContactGetBounce dContactGetBounce = (JVODE_DLL_dContactGetBounce)GetProcAddress(hDLL,"_odeContactGetBounce@0");
typedef void(WINAPI *JVODE_DLL_dContactSetBounceVel) (float vel);
JVODE_DLL_dContactSetBounceVel dContactSetBounceVel = (JVODE_DLL_dContactSetBounceVel)GetProcAddress(hDLL,"_odeContactSetBounceVel@4");
typedef float(WINAPI *JVODE_DLL_dContactGetBounceVel) ();
JVODE_DLL_dContactGetBounceVel dContactGetBounceVel = (JVODE_DLL_dContactGetBounceVel)GetProcAddress(hDLL,"_odeContactGetBounceVel@0");
typedef void(WINAPI *JVODE_DLL_dContactSetSoftERP) (float erp);
JVODE_DLL_dContactSetSoftERP dContactSetSoftERP = (JVODE_DLL_dContactSetSoftERP)GetProcAddress(hDLL,"_odeContactSetSoftERP@4");
typedef float(WINAPI *JVODE_DLL_dContactGetSoftERP) ();
JVODE_DLL_dContactGetSoftERP dContactGetSoftERP = (JVODE_DLL_dContactGetSoftERP)GetProcAddress(hDLL,"_odeContactGetSoftERP@0");
typedef void(WINAPI *JVODE_DLL_dContactSetSoftCFM) (float cfm);
JVODE_DLL_dContactSetSoftCFM dContactSetSoftCFM = (JVODE_DLL_dContactSetSoftCFM)GetProcAddress(hDLL,"_odeContactSetSoftCFM@4");
typedef float(WINAPI *JVODE_DLL_dContactGetSoftCFM) ();
JVODE_DLL_dContactGetSoftCFM dContactGetSoftCFM = (JVODE_DLL_dContactGetSoftCFM)GetProcAddress(hDLL,"_odeContactGetSoftCFM@0");
typedef void(WINAPI *JVODE_DLL_dContactSetMotion1) (float motion);
JVODE_DLL_dContactSetMotion1 dContactSetMotion1 = (JVODE_DLL_dContactSetMotion1)GetProcAddress(hDLL,"_odeContactSetMotion1@4");
typedef float(WINAPI *JVODE_DLL_dContactGetMotion1) ();
JVODE_DLL_dContactGetMotion1 dContactGetMotion1 = (JVODE_DLL_dContactGetMotion1)GetProcAddress(hDLL,"_odeContactGetMotion1@0");
typedef void(WINAPI *JVODE_DLL_dContactSetMotion2) (float motion);
JVODE_DLL_dContactSetMotion2 dContactSetMotion2 = (JVODE_DLL_dContactSetMotion2)GetProcAddress(hDLL,"_odeContactSetMotion2@4");
typedef float(WINAPI *JVODE_DLL_dContactGetMotion2) ();
JVODE_DLL_dContactGetMotion2 dContactGetMotion2 = (JVODE_DLL_dContactGetMotion2)GetProcAddress(hDLL,"_odeContactGetMotion2@0");
typedef void(WINAPI *JVODE_DLL_dContactSetSlip1) (float slip);
JVODE_DLL_dContactSetSlip1 dContactSetSlip1 = (JVODE_DLL_dContactSetSlip1)GetProcAddress(hDLL,"_odeContactSetSlip1@4");
typedef float(WINAPI *JVODE_DLL_dContactGetSlip1) ();
JVODE_DLL_dContactGetSlip1 dContactGetSlip1 = (JVODE_DLL_dContactGetSlip1)GetProcAddress(hDLL,"_odeContactGetSlip1@0");
typedef void(WINAPI *JVODE_DLL_dContactSetSlip2) (float slip);
JVODE_DLL_dContactSetSlip2 dContactSetSlip2 = (JVODE_DLL_dContactSetSlip2)GetProcAddress(hDLL,"_odeContactSetSlip2@4");
typedef float(WINAPI *JVODE_DLL_dContactGetSlip2) ();
JVODE_DLL_dContactGetSlip2 dContactGetSlip2 = (JVODE_DLL_dContactGetSlip2)GetProcAddress(hDLL,"_odeContactGetSlip2@0");

// ### Geom Contact Functions (Unique JV-ODE Functions)
typedef void(WINAPI *JVODE_DLL_dGeomContactSetMode) (int geom, int mode);
JVODE_DLL_dGeomContactSetMode dGeomContactSetMode = (JVODE_DLL_dGeomContactSetMode)GetProcAddress(hDLL,"_odeGeomContactSetMode@8");
typedef int(WINAPI *JVODE_DLL_dGeomContactGetMode) (int geom);
JVODE_DLL_dGeomContactGetMode dGeomContactGetMode = (JVODE_DLL_dGeomContactGetMode)GetProcAddress(hDLL,"_odeGeomContactGetMode@4");
typedef void(WINAPI *JVODE_DLL_dGeomContactSetMu) (int geom, float mu);
JVODE_DLL_dGeomContactSetMu dGeomContactSetMu = (JVODE_DLL_dGeomContactSetMu)GetProcAddress(hDLL,"_odeGeomContactSetMu@8");
typedef float(WINAPI *JVODE_DLL_dGeomContactGetMu) (int geom);
JVODE_DLL_dGeomContactGetMu dGeomContactGetMu = (JVODE_DLL_dGeomContactGetMu)GetProcAddress(hDLL,"_odeGeomContactGetMu@4");
typedef void(WINAPI *JVODE_DLL_dGeomContactSetMu2) (int geom, float mu);
JVODE_DLL_dGeomContactSetMu2 dGeomContactSetMu2 = (JVODE_DLL_dGeomContactSetMu2)GetProcAddress(hDLL,"_odeGeomContactSetMu2@8");
typedef float(WINAPI *JVODE_DLL_dGeomContactGetMu2) (int geom);
JVODE_DLL_dGeomContactGetMu2 dGeomContactGetMu2 = (JVODE_DLL_dGeomContactGetMu2)GetProcAddress(hDLL,"_odeGeomContactGetMu2@4");
typedef void(WINAPI *JVODE_DLL_dGeomContactSetFDir1) (int geom, float fdir1x, float fdir1y, float fdir1z);
JVODE_DLL_dGeomContactSetFDir1 dGeomContactSetFDir1 = (JVODE_DLL_dGeomContactSetFDir1)GetProcAddress(hDLL,"_odeGeomContactSetFDir1@16");
typedef void(WINAPI *JVODE_DLL_dGeomContactGetFDir1) (int geom);
JVODE_DLL_dGeomContactGetFDir1 dGeomContactGetFDir1 = (JVODE_DLL_dGeomContactGetFDir1)GetProcAddress(hDLL,"_odeGeomContactGetFDir1@4");
typedef void(WINAPI *JVODE_DLL_dGeomContactSetBounce) (int geom, float bounce);
JVODE_DLL_dGeomContactSetBounce dGeomContactSetBounce = (JVODE_DLL_dGeomContactSetBounce)GetProcAddress(hDLL,"_odeGeomContactSetBounce@8");
typedef float(WINAPI *JVODE_DLL_dGeomContactGetBounce) (int geom);
JVODE_DLL_dGeomContactGetBounce dGeomContactGetBounce = (JVODE_DLL_dGeomContactGetBounce)GetProcAddress(hDLL,"_odeGeomContactGetBounce@4");
typedef void(WINAPI *JVODE_DLL_dGeomContactSetBounceVel) (int geom, float vel);
JVODE_DLL_dGeomContactSetBounceVel dGeomContactSetBounceVel = (JVODE_DLL_dGeomContactSetBounceVel)GetProcAddress(hDLL,"_odeGeomContactSetBounceVel@8");
typedef float(WINAPI *JVODE_DLL_dGeomContactGetBounceVel) (int geom);
JVODE_DLL_dGeomContactGetBounceVel dGeomContactGetBounceVel = (JVODE_DLL_dGeomContactGetBounceVel)GetProcAddress(hDLL,"_odeGeomContactGetBounceVel@4");
typedef void(WINAPI *JVODE_DLL_dGeomContactSetSoftERP) (int geom, float erp);
JVODE_DLL_dGeomContactSetSoftERP dGeomContactSetSoftERP = (JVODE_DLL_dGeomContactSetSoftERP)GetProcAddress(hDLL,"_odeGeomContactSetSoftERP@8");
typedef float(WINAPI *JVODE_DLL_dGeomContactGetSoftERP) (int geom);
JVODE_DLL_dGeomContactGetSoftERP dGeomContactGetSoftERP = (JVODE_DLL_dGeomContactGetSoftERP)GetProcAddress(hDLL,"_odeGeomContactGetSoftERP@4");
typedef void(WINAPI *JVODE_DLL_dGeomContactSetSoftCFM) (int geom, float cfm);
JVODE_DLL_dGeomContactSetSoftCFM dGeomContactSetSoftCFM = (JVODE_DLL_dGeomContactSetSoftCFM)GetProcAddress(hDLL,"_odeGeomContactSetSoftCFM@8");
typedef float(WINAPI *JVODE_DLL_dGeomContactGetSoftCFM) (int geom);
JVODE_DLL_dGeomContactGetSoftCFM dGeomContactGetSoftCFM = (JVODE_DLL_dGeomContactGetSoftCFM)GetProcAddress(hDLL,"_odeGeomContactGetSoftCFM@4");
typedef void(WINAPI *JVODE_DLL_dGeomContactSetMotion1) (int geom, float motion);
JVODE_DLL_dGeomContactSetMotion1 dGeomContactSetMotion1 = (JVODE_DLL_dGeomContactSetMotion1)GetProcAddress(hDLL,"_odeGeomContactSetMotion1@8");
typedef float(WINAPI *JVODE_DLL_dGeomContactGetMotion1) (int geom);
JVODE_DLL_dGeomContactGetMotion1 dGeomContactGetMotion1 = (JVODE_DLL_dGeomContactGetMotion1)GetProcAddress(hDLL,"_odeGeomContactGetMotion1@4");
typedef void(WINAPI *JVODE_DLL_dGeomContactSetMotion2) (int geom, float motion);
JVODE_DLL_dGeomContactSetMotion2 dGeomContactSetMotion2 = (JVODE_DLL_dGeomContactSetMotion2)GetProcAddress(hDLL,"_odeGeomContactSetMotion2@8");
typedef float(WINAPI *JVODE_DLL_dGeomContactGetMotion2) (int geom);
JVODE_DLL_dGeomContactGetMotion2 dGeomContactGetMotion2 = (JVODE_DLL_dGeomContactGetMotion2)GetProcAddress(hDLL,"_odeGeomContactGetMotion2@4");
typedef void(WINAPI *JVODE_DLL_dGeomContactSetSlip1) (int geom, float slip);
JVODE_DLL_dGeomContactSetSlip1 dGeomContactSetSlip1 = (JVODE_DLL_dGeomContactSetSlip1)GetProcAddress(hDLL,"_odeGeomContactSetSlip1@8");
typedef float(WINAPI *JVODE_DLL_dGeomContactGetSlip1) (int geom);
JVODE_DLL_dGeomContactGetSlip1 dGeomContactGetSlip1 = (JVODE_DLL_dGeomContactGetSlip1)GetProcAddress(hDLL,"_odeGeomContactGetSlip1@4");
typedef void(WINAPI *JVODE_DLL_dGeomContactSetSlip2) (int geom, float slip);
JVODE_DLL_dGeomContactSetSlip2 dGeomContactSetSlip2 = (JVODE_DLL_dGeomContactSetSlip2)GetProcAddress(hDLL,"_odeGeomContactSetSlip2@8");
typedef float(WINAPI *JVODE_DLL_dGeomContactGetSlip2) (int geom);
JVODE_DLL_dGeomContactGetSlip2 dGeomContactGetSlip2 = (JVODE_DLL_dGeomContactGetSlip2)GetProcAddress(hDLL,"_odeGeomContactGetSlip2@4");
typedef void(WINAPI *JVODE_DLL_dGeomContactSetDefaults) (int geom);
JVODE_DLL_dGeomContactSetDefaults dGeomContactSetDefaults = (JVODE_DLL_dGeomContactSetDefaults)GetProcAddress(hDLL,"_odeGeomContactSetDefaults@4");

// ### Geom Collision Functions (Unique JV-ODE Functions)
typedef int(WINAPI *JVODE_DLL_dGeom1CountCollisions) (int geom);
JVODE_DLL_dGeom1CountCollisions dGeom1CountCollisions = (JVODE_DLL_dGeom1CountCollisions)GetProcAddress(hDLL,"_odeGeom1CountCollisions@4");
typedef int(WINAPI *JVODE_DLL_dGeom1CollisionGeom) (int geom, int index);
JVODE_DLL_dGeom1CollisionGeom dGeom1CollisionGeom = (JVODE_DLL_dGeom1CollisionGeom)GetProcAddress(hDLL,"_odeGeom1CollisionGeom@8");
typedef float(WINAPI *JVODE_DLL_dGeom1CollisionX) (int geom, int index);
JVODE_DLL_dGeom1CollisionX dGeom1CollisionX = (JVODE_DLL_dGeom1CollisionX)GetProcAddress(hDLL,"_odeGeom1CollisionX@8");
typedef float(WINAPI *JVODE_DLL_dGeom1CollisionY) (int geom, int index);
JVODE_DLL_dGeom1CollisionY dGeom1CollisionY = (JVODE_DLL_dGeom1CollisionY)GetProcAddress(hDLL,"_odeGeom1CollisionY@8");
typedef float(WINAPI *JVODE_DLL_dGeom1CollisionZ) (int geom, int index);
JVODE_DLL_dGeom1CollisionZ dGeom1CollisionZ = (JVODE_DLL_dGeom1CollisionZ)GetProcAddress(hDLL,"_odeGeom1CollisionZ@8");
typedef float(WINAPI *JVODE_DLL_dGeom1CollisionNX) (int geom, int index);
JVODE_DLL_dGeom1CollisionNX dGeom1CollisionNX = (JVODE_DLL_dGeom1CollisionNX)GetProcAddress(hDLL,"_odeGeom1CollisionNX@8");
typedef float(WINAPI *JVODE_DLL_dGeom1CollisionNY) (int geom, int index);
JVODE_DLL_dGeom1CollisionNY dGeom1CollisionNY = (JVODE_DLL_dGeom1CollisionNY)GetProcAddress(hDLL,"_odeGeom1CollisionNY@8");
typedef float(WINAPI *JVODE_DLL_dGeom1CollisionNZ) (int geom, int index);
JVODE_DLL_dGeom1CollisionNZ dGeom1CollisionNZ = (JVODE_DLL_dGeom1CollisionNZ)GetProcAddress(hDLL,"_odeGeom1CollisionNZ@8");
typedef float(WINAPI *JVODE_DLL_dGeom1CollisionDepth) (int geom, int index);
JVODE_DLL_dGeom1CollisionDepth dGeom1CollisionDepth = (JVODE_DLL_dGeom1CollisionDepth)GetProcAddress(hDLL,"_odeGeom1CollisionDepth@8");
typedef int(WINAPI *JVODE_DLL_dGeom2CountCollisions) (int geom);
JVODE_DLL_dGeom2CountCollisions dGeom2CountCollisions = (JVODE_DLL_dGeom2CountCollisions)GetProcAddress(hDLL,"_odeGeom2CountCollisions@4");
typedef int(WINAPI *JVODE_DLL_dGeom2CollisionGeom) (int geom, int index);
JVODE_DLL_dGeom2CollisionGeom dGeom2CollisionGeom = (JVODE_DLL_dGeom2CollisionGeom)GetProcAddress(hDLL,"_odeGeom2CollisionGeom@8");
typedef float(WINAPI *JVODE_DLL_dGeom2CollisionX) (int geom, int index);
JVODE_DLL_dGeom2CollisionX dGeom2CollisionX = (JVODE_DLL_dGeom2CollisionX)GetProcAddress(hDLL,"_odeGeom2CollisionX@8");
typedef float(WINAPI *JVODE_DLL_dGeom2CollisionY) (int geom, int index);
JVODE_DLL_dGeom2CollisionY dGeom2CollisionY = (JVODE_DLL_dGeom2CollisionY)GetProcAddress(hDLL,"_odeGeom2CollisionY@8");
typedef float(WINAPI *JVODE_DLL_dGeom2CollisionZ) (int geom, int index);
JVODE_DLL_dGeom2CollisionZ dGeom2CollisionZ = (JVODE_DLL_dGeom2CollisionZ)GetProcAddress(hDLL,"_odeGeom2CollisionZ@8");
typedef float(WINAPI *JVODE_DLL_dGeom2CollisionNX) (int geom, int index);
JVODE_DLL_dGeom2CollisionNX dGeom2CollisionNX = (JVODE_DLL_dGeom2CollisionNX)GetProcAddress(hDLL,"_odeGeom2CollisionNX@8");
typedef float(WINAPI *JVODE_DLL_dGeom2CollisionNY) (int geom, int index);
JVODE_DLL_dGeom2CollisionNY dGeom2CollisionNY = (JVODE_DLL_dGeom2CollisionNY)GetProcAddress(hDLL,"_odeGeom2CollisionNY@8");
typedef float(WINAPI *JVODE_DLL_dGeom2CollisionNZ) (int geom, int index);
JVODE_DLL_dGeom2CollisionNZ dGeom2CollisionNZ = (JVODE_DLL_dGeom2CollisionNZ)GetProcAddress(hDLL,"_odeGeom2CollisionNZ@8");
typedef float(WINAPI *JVODE_DLL_dGeom2CollisionDepth) (int geom, int index);
JVODE_DLL_dGeom2CollisionDepth dGeom2CollisionDepth = (JVODE_DLL_dGeom2CollisionDepth)GetProcAddress(hDLL,"_odeGeom2CollisionDepth@8");

// ### Vector Functions (Unique JV-ODE Functions)
typedef float(WINAPI *JVODE_DLL_dVectorW) ();
JVODE_DLL_dVectorW dVectorW = (JVODE_DLL_dVectorW)GetProcAddress(hDLL,"_odeVectorW@0");
typedef float(WINAPI *JVODE_DLL_dVectorX) ();
JVODE_DLL_dVectorX dVectorX = (JVODE_DLL_dVectorX)GetProcAddress(hDLL,"_odeVectorX@0");
typedef float(WINAPI *JVODE_DLL_dVectorY) ();
JVODE_DLL_dVectorY dVectorY = (JVODE_DLL_dVectorY)GetProcAddress(hDLL,"_odeVectorY@0");
typedef float(WINAPI *JVODE_DLL_dVectorZ) ();
JVODE_DLL_dVectorZ dVectorZ = (JVODE_DLL_dVectorZ)GetProcAddress(hDLL,"_odeVectorZ@0");

// ### Misc Functions (Unique JV-ODE Functions)
typedef float(WINAPI *JVODE_DLL_dGetVersion) ();
JVODE_DLL_dGetVersion dGetVersion = (JVODE_DLL_dGetVersion)GetProcAddress(hDLL,"_odeGetVersion@0");
typedef void(WINAPI *JVODE_DLL_dRegisterODE) (int key1, int key2, int key3, int key4);
JVODE_DLL_dRegisterODE dRegisterODE = (JVODE_DLL_dRegisterODE)GetProcAddress(hDLL,"_odeRegisterODE@16");
